cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c	SUBROUTINE INITRNG(TJDINT,SECUTC,ITRANS,IRECVR,POLEXY,
c     1		AUKM,EPOCH,STVEC,UT1C,EMUTC,XPOLE,YPOLE,
c     2		DEPS,DPSI,DTADT)      
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE INITRNG(TJDINT,SECUTC,JTRANS,JRECVR,POLEXY,AUKM,
     1		STVEC,UT1C,EMUTC,XPOLE,YPOLE,
     2		EOSRC,DEPS,DPSI,DTADT)
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'LICENSE-BSD3.inc'
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  Mon Aug 29, 1988 14:14:31
C     1) REPLACE "COMPILER DOUBLE PRECISION" WITH
C        "IMPLICIT DOUBLE PRECISION (A-H,O-Z)".
C     2) MAKE SURE STATEMENTS DON'T EXTEND BEYOND COLUMN 72.
C     3) CHANGE OPTIONAL COMPILE STATEMENTS TO COMMENTS. 
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
c 02 May 90, 1627- remove formal parameter "epoch" (from
c		   call to UT1UTC also)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C:%S INITIALIZATION FOR RANGE COMPUTATION
C:OBTAIN FUNDAMENTAL ARGUMENTS
C:COMPUTE EPHEMERIS MINUS UTC AND RELATIVISTIC CLOCK CORRECTIONS
C:COMPUTE EARTH ROTATION PARAMETER UT1 MINUS UTC
C:COMPUTE NUTATION CORRECTIONS FOR EARTH ELASTICITY AND FLUID CORE
C:IF DESIRE TRANSMITTER AND RECEIVER RELATIVE/
C:TO THE INSTANTANEOUS POLE
C:OBTAIN POLAR MOTION PARAMETERS X AND Y OF THE POLE
C:APPLY POLAR MOTION X,Y CORRECTIONS TO THE TELESCOPE (WHICH/
C:TRANSMITS)
C:IF THE RECEIVER NOT THE TRANSMITTER
C:APPLY POLR MOTIN X,Y CORRECTIONS TO THE TELESCOPE (WHICH/
C:RECEIVES)
C:ENDIF
C:ENDIF
C:CONVERT COORDINATES FROM SPHERICAL TO RECTANGULAR, IN UNITS OF AU /
C:(FOR THE TRANSMITTER)
C:IF THE RECEIVER NOT THE TRANSMITTER
C:CONVERT COORDINATES FROM SPHERICAL TO RECTANGULAR, IN UNITS OF AU /
C:(FOR THE RECEIVER)
C:ELSE
C:SET THE RECEIVER COORDINATES TO THE TRANSMITTER COORDINATES
C:ENDIF
C:COMPUTE HELIOCENTRIC EPHEMERIS STATE VECTOR OF THE TELSCOPE (AT/
C:TRANSMISSION TIME)
C:CONVVERT COORDINATED FROM SPHERICAL TO RECTANGULAR, IN UNITS OF AU /
C:(FOR THE REFLECTOR)
C  REVISIONS:
C	04/22/83 - ELCORE REMOVED AS WAHR NUTATION MODEL (USED BY MIT PEP)
C		   INCLUDED THIS EFFECT.  RLR.
C	09/01/87 - RETURN EARTH ROTATION SOURCE. V01. RLR.
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

	character*(*) sccsid
	parameter (sccsid = "%W%\t%G%")

	INCLUDE 'INTRNG.INC'

	INCLUDE 'PDCMN.INC'

	INCLUDE 'DIRCTN.INC'

	INCLUDE 'DEFCMN.INC'

	INCLUDE 'DEVCOM.INC'

CCC      DOUBLE PRECISION PRECM(6,3)
      DOUBLE PRECISION STVEC(6)
      CHARACTER*1 EOSRC
      LOGICAL POLEXY

C.....INPUT TIME TO FUNARG IS IN JULIAN CENTURIES FROM 2415020.0
      TJDUTC=TJDINT + SECUTC/86400.D0
      T1=(TJDUTC - 2415020.0D0)/36525.0D0
      CALL FUNARG(T1)
      IFLAG=0
      CALL CLKCOR(TJDUTC,TRANSM,EMUTC,DTADT)

c...WOULD BE SAME IF TAKEN FROM X,Y
      CALL UT1UTC(TJDUTC,EMUTC,UT1C,EOSRC)
      DEPS = 0.D0
      DPSI = 0.D0
c...ELASTIC CORE IS IN MIT WAHR MODEL
      IF (.NOT.WAHR) CALL ELCORE(DEPS,DPSI)
      IF (.NOT.POLEXY) GO TO 100
      CALL XYPOLE(TJDUTC,T1,EMUTC,XPOLE,YPOLE)
      CALL WOBBLE(TRANSM,XPOLE,YPOLE)
      IF (JTRANS.EQ.JRECVR) GO TO 100
      CALL WOBBLE(RECEIV,XPOLE,YPOLE)
  100 CONTINUE
      CALL CNVCOOR(AUKM,TRANSM,BODTRN)
      DO 200 I=1,6
  200 BODRCV(I)=BODTRN(I)
      IF (JTRANS.NE.JRECVR)
     $ CALL CNVCOOR(AUKM,RECEIV,BODRCV)
      CALL CNVCOOR(AUKM,REFLCT,BODRFL)
      LEGDIR=1
      CALL EPHTEL(TJDINT,SECUTC,BODTRN,UT1C,EMUTC,DEPS,DPSI,STVEC)
C
C	   THE
	   END


	SUBROUTINE RECTNG(SPHERE,XYZ)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C:%S COMPUTE RECTANGULAR COORDINATES FROM SPHERICAL COORDINATES
C:COMPUTE SIN AND COS OF LONGITUDE
C:COMPUTE SIN AND COS OF LATITUDE
C:COMPUTE QUANTITY COS(LAT) COS(LONG)
C:COMPUTE QUANTITY COS(LAT) SIN(LONG)
C:COMPUTE QUANTITY SIN(LAT) COS(LONG)
C:COMPUTE QUANTITY SIN(LAT) SIN(LONG)
C:COMPUTE X = R COS(LAT) COS(LONG)
C:COMPUTE Y = R COS(LAT) SIN(LONG)
C:COMPUTE Z = R COS(LAT)
C:(NOW THE RATES OF X, Y AND Z)
C:COMPUTE XD = RD COS(LAT) COS(LONG) - R (LONGD COS(LAT) SIN(LONG) +/ 
C: LATD SIN(LAT) COS(LONG))
C:COMPUTE YD = RD COS(LAT) SIN(LONG) + R (LONGD COS(LAT) COS(LONG) -/ 
C: LATD SIN(LAT) SIN(LONG))
C:COMPUTE ZD = RD SIN(LAT) + R LATD COS(LAT)
      DOUBLE PRECISION SPHERE(6),XYZ(6) 
      SINLON = DSIN(SPHERE(2))
      COSLON = DCOS(SPHERE(2))
      SINLAT = DSIN(SPHERE(3))
      COSLAT = DCOS(SPHERE(3))
      CC = COSLAT*COSLON
      CS = COSLAT*SINLON
      SC = SINLAT*COSLON
      SS = SINLAT*SINLON
      XYZ(1) = SPHERE(1)*CC
      XYZ(2) = SPHERE(1)*CS
      XYZ(3) = SPHERE(1)*SINLAT
      XYZ(4) = SPHERE(4)*CC - SPHERE(1)*(SPHERE(5)*CS+SPHERE(6)*SC)
      XYZ(5) = SPHERE(4)*CS + SPHERE(1)*(SPHERE(5)*CC-SPHERE(6)*SS)
      XYZ(6) = SPHERE(4)*SINLAT + SPHERE(1)*SPHERE(6)*COSLAT
C
C	   THE
	   END


	SUBROUTINE EPHINIT(AUKM,REM)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Oct 89 - tlr:  read time from file "CUTABLE"
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c 31 Jul 90, 1435: close unit 47 after use.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

	INCLUDE 'ATMAUX.INC'

	INCLUDE 'CETB1.INC'

	INCLUDE 'CETB2.INC'
  
	INCLUDE 'COMARG.INC'
  
	INCLUDE 'DEVCOM.INC'

	INCLUDE 'LIB.INC'

c Read in the TIME array from file CUTABLE.
	open(47,status='old',file=pathfil(1:lenfil)//'CUTABLE',
     1		err=98,iostat=ios)
	read(47,*,END=90)(time(i),i=1,201)
90	close (47)
c find ltim
	do 97 i97=1,201
	if(dabs(time(i97)-2600000.5d0) .LT. 0.1d0)ltim=i97
97	continue


C  NUMBER OF USER UNITS IN AN AU
      AU = 1.D0
C  NUMBER OF OUTPUT LINEAR UNITS IN AN EARTH RADIUS
c  (If reference is CALL EPHINIT(AUKM,AUKM), then RE=1.d0)
      RE = REM/AUKM
 
C  NUMBER OF OUTPUT TIME UNITS IN AN EPHEMERIS DAY
      TPD = 1.D0
 
C  SET FLAG USED WITHIN READE
      ICW = 3
 
C  SET INDEX OF BODY TO BE USED AS CENTRAL BODY RELATIVE TO WHICH
C  COORDINATES OF EARTH AND MOON FROM READE WILL BE GIVEN, VALUE FOR
C  THE SUN IS 10 
      ICENT = 10
 
C  THE FOLLOWING IREQ(J) ARRAY SPECIFIES THE TYPE OF OUTPUT
C  FROM READE FOR INDEX J, IREQ(J) = 0 MEANS NO OUTPUT
C                                    1 MEANS POSITION ONLY
C                                    2 MEANS POSITION AND VELOCITY 
 
C  INITIALIZE IREQ ARRAY TO 0
      DO 10 J = 1,13
   10 IREQ(J) = 0
C  SET IREQ(13), FOR NUTATION PARAMETERS, TO 2 
      IREQ(13) = 2
C  SET IREQ(3), FOR EARTH, TO 2
      IREQ(3) = 2
      IREQ(11) = 2

C  COMPUTE LIBRATIONS
      ILIB = 1
      goto 10000

ccc98	continue
ccc5998	format(' Error in EPHINIT when opening file "CUTABLE".',/,
ccc     1	    ' iostatus is ',i9)
ccc	write(ierrout,5998)ios
ccc	stop

98	continue
	errmsg=' Error in EPHINIT: open "CUTABLE". iostatus shown below'
	call error(ios,errmsg,ios,ios)
10000	continue
C
C	   THE
	   END


	SUBROUTINE EPHTEL(JDINT,SECUTC,BODTEL,UT1C,
     1		EMUTC,DEPS,DPSI,STVEC)
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  Wed Aug 31, 1988 14:56:02
C     1) REPLACE "COMPILER DOUBLE PRECISION" WITH
C        "IMPLICIT DOUBLE PRECISION (A-H,O-Z)".
C     2) MAKE SURE STATEMENTS DON'T EXTEND BEYOND COLUMN 72.
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  Tue Oct 25, 1988 09:53:10
C     1) REMOVE IN-LINE COMMENTS.
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  Thu Apr 6, 1989 16:43:26
C     USE ONLY SECONDS (NOT ENTIRE JULIAN DATE) WHEN
C     CALCULATING GHAS(1) = DMOD . . .
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C 08 Mar 91, 1504: change "stop" to "call error"
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C:%S COMPUTE HELIOCENTRIC EPHEMERIS STATE VECTOR OF THE TELESCOPE
C:EPHEMERIS READ (OBTAIN THE HELIOCENTRIC, SPACE FIXED, RECTANGULAR
C:STATE VECTOR OF THE EARTH AND THE NUTATIONS WITH THEIR RATES)
C:IF NOT ERROR WHILE EPHEMERIS READ
C:APPLY NUTATION CORRECTIONS THAT CONSIDER THE ELASTICITY AND FLUID
C:CORE OF THE EARTH
C:COMPUTE THE MEAN OBLIQUITY OF THE ECLIPTIC AND ITS RATE
C:COMPUTE AUGMENTED ROTATION MATRIX FOR NUTATION (THE MEAN OBLIQUITY
C:AND THE NUTATIONS IN LONGITUDE AND OBLIQUITY WITH THEIR RATES ARE
C:REQUIRED)
C:COMPUTE AUGMENTED ROTATION MATRIX FOR PRECESSION
C:MATRIX MUILTIPLICATION (CONSTRUCT THE AUGMENTED ROTATION MATRIX
C:FOR COMBINED NUTATION AND PRECESSION BY PREMULTILYING THE
C:MATRIX [N] BY THE MATRIX [P])
C:CORRECT TIME FOR UT1 MINUS UTC (REQUIRED TO COMPUTE THE GREENWICH
C:APPARENT SIDEREAL TIME)
C:COMPUTE THE RIGHT ASCENSION OF THE MEAN SUN AND ITS RATE (INPUT IS THE
C:UT1 JULIAN DATE)
C:COMPUTE THE GREENWICH HOUR ANGLE OF THE SUN PLUS 12 HOURS (THIS IS
C:EQUAL TO THE FRACTIONAL PART OF THE UT1 JULIAN DATE IN RADIANS)
C:COMPUTE THE DAILY RATE OF THE HOUR ANGLE OF THE SUN (SET EQUAL TO
C:TWOPI)
C:COMPUTE GREENWICH APPARENT SIDEREAL TIME (THIS IS EQUAL TO THE R.A.
C:OF THE MEAN SUN + NUTATION IN R.A. + GREENWICH HOUR ANGLE OF THE SUN
C:+ 12 HOURS)
C:COMPUTE RATE OF GREENWICH APPARENT SIDEREAL TIME (THIS IS EQUAL TO
C:THE SUM OF THE RATES OF THE TERMS OF THE PREVIOUS SUMMATION)
C:CONSTRUCT AUGMENTED ROTATION MATRIX [S] FOR TRANSFORMATION FROM THE
C:BODY FIXED TERRESTRIAL SYSTEM OF THE EARTH TO THE TRUE CELESTIAL
C:SYSTEM OF DATE
C:(THIS INVOLVES A ROTATION THROUGH AN ANGLE CORRESPONDING TO THE
C:G.A.S.T.)
C:MATRIX MULTIPLICATION (TRANSFORM TRANSMITTER STATE VECTOR BY
C:MULTIPLYING THE CURRENT BODY FIXED TELESCOPE STATE VECTOR
C:BY MATRIX [S])
C:MATRIX MULTIPLICATION (TRANSFORM TELESCOPE STATE VECTOR FROM
C:THE TRUE EQUATORIAL SYSTEM OF DATE TO THE MEAN EQUATORIAL SYSTEM
C:OF THE EPHEMERIS BY PREMULTIPLYING THE CURRENT TELESCOPE STATE
C:VECTOR BY THE COMBINED MATRICES [N] AND [P])
C:MATRIX ADDITION (TRANSFORM EARTH CENTERED, SPACE FIXED, RECTANGULAR
C:STATE VECTOR OF THE TELESCOPE TO A HELIOCENTRIC, SPACE FIXED
C:RECTANGULAR STATE VECTOR BY ADDING THE CURRENT STATE VECTOR OF THE
C:TELESCOPE TO THE EPHEMERIS, HELIOCENTRIC, SPACE FIXED, RECTANGULAR
C:STATE VECTOR OF THE EARTH)
C:ELSE CALL READ ERROR ROUTINE; STOP
C:ENDIF
C  REVISIONS:
C	05/05/83 - INPUT CHANGED FROM JD TO JDINT & SECEPH DUE TO
C			 PRECISION INADEQUACIES. 
C	05/26/83 - PUT IN SOLID BODY EARTH TIDE CALCULATIONS (SBETID)
C
CCC TYPE DOUBLE PRECISION INSTEAD OF REAL. Wed Aug 31, 1988 14:59:50 CCC
      DIMENSION XNUTLN(2),XNUTOB(2)
      DIMENSION EPSLM(2),GASTM(6,3)
      DOUBLE PRECISION NUTAM(6,3),NUTPRM(6,3),PRECM
      DIMENSION XNUTRA(2),RAMSN(2),GHAS(2),GAST(2)
      DIMENSION BODTEL(6),CELTEL(6),EPHMTEL(6)
      DIMENSION SEVEC(6),STVEC(6)

      DOUBLE PRECISION JD1950
      DOUBLE PRECISION JDUTC,JDUT1,JDINT

      COMMON/TWOPI/TWOPI,CDR,CASR,CTSR

	INCLUDE 'EPHREC.INC'

	INCLUDE 'DEFCMN.INC'

	INCLUDE 'DEVCOM.INC'

	INCLUDE 'CETB4.INC'

	INCLUDE 'DIRCTN.INC'

	INCLUDE 'CETB2.INC'

	INCLUDE 'PNT.INC'

	INCLUDE 'PRMAT.INC'

      JD1950=2433282.423D0
      JDUTC=JDINT + SECUTC/86400.D0
      SECEPH=SECUTC + EMUTC
      IREQ(3)=2
      IREQ(11)=2
      IERR = 0
      CALL READE(JDINT,SECEPH,IERR)
      IF (IERR.EQ.0) GO TO 10
ccc      WRITE (ierrout,1000) IERR
ccc 1000 FORMAT (5X,"IN EPHTEL, ERROR WHILE EPHEMERIS READ",1X,I2/
ccc     1	  7X,"INPUT TIME IS (1)EARLIER THAN, (2)LATER THAN EPHEMERIS")
ccc      STOP
	if(ierr .EQ. 1) then
	  errmsg=' EPHTEL: input time earlier than ephemeris.'
	elseif(ierr .EQ. 2) then
	  errmsg=' EPHTEL: input time later than ephemeris.'
	else
	  errmsg=' EPHTEL: bad error code from READE.'
	endif
	call error(5,errmsg,ierr,ierr)

10	CONTINUE
	DO 20 I=1,6
	SEVEC(I)=TABOUT(I,3)
20	CONTINUE
      IREQ(3)=0
      XNUTLN(1)=NUT(1) + DPSI
      XNUTOB(1)=NUT(2) + DEPS
      XNUTLN(2)=NUT(3)
      XNUTOB(2)=NUT(4)
      CALL OBLIQ(JDUTC,EPSLM)
      CALL NUTATE(XNUTLN,XNUTOB,EPSLM,NUTAM)
      CALL PRECESS(JD1950,JDUTC,PRECM)
      CALL MATMUL(NUTAM,PRECM,NUTPRM,6,3,3)
      XNUTRA(1)=NUTAM(2,1)
      XNUTRA(2)=NUTAM(5,1)
      JDUT1=JDUTC + UT1C/86400.0D0
      CALL RAMSUN(JDUT1,RAMSN)
CCC	GHAS(1)=DMOD(JDUT1,1.0D0)*TWOPI     ?????
	SECUT1 = (SECUTC + UT1C)/86400.0D0
	GHAS(1)=DMOD(SECUT1,1.0D0)*TWOPI
      GHAS(2)=TWOPI
      GAST(1)=RAMSN(1) + XNUTRA(1) + GHAS(1)
      GAST(2)=RAMSN(2) + XNUTRA(2) + GHAS(2)
      CALL ROTMAT(+3,GAST,GASTM)
      CALL MATMUL(GASTM,BODTEL,CELTEL,6,3,1)
      CALL MATTRNS(NUTPRM,6,3)
C		PRECM USED IN BAKLEG
      CALL MATTRNS(PRECM,6,3)
      CALL MATMUL(NUTPRM,CELTEL,EPHMTEL,6,3,1)
C		SOLID BODY EARTH TIDE
      CALL SBETID(EPHMTEL,GASTM,NUTPRM)
      CALL MATADD(SEVEC,EPHMTEL,STVEC,6)
      GO TO(100,200) LEGDIR
  100 DO 110 I=1,6
      DO 105 J=1,3
      TNUTPRM(I,J)=NUTPRM(I,J)
      TGASTM(I,J)=GASTM(I,J)
      RECD(3)= GAST(1)
  105 CONTINUE
  110 CONTINUE
      GO TO 300
  200 DO 210 I=1,6
      DO 205 J=1,3
      RNUTPRM(I,J)=NUTPRM(I,J)
      RGASTM(I,J)=GASTM(I,J)
  205 CONTINUE
  210 CONTINUE
  300 CONTINUE
       	IF (DEB(13)) WRITE(DUNIT,1010) SECUTC,SECEPH,NUT,DPSI,
     1		DEPS,GHAS,GAST,RAMSN,CELTEL,SEVEC,STVEC
 1010	FORMAT(' EPHTEL: SECUTC,SECEPH,NUT,DPSI,DEPS ',2E24.14/,
     1		1X,6E20.10/
     X         ' GHAS,GAST,RAMSN,CELTEL,SEVEC,STVEC',8(/1X,3E22.14))
C
C	   THE
	   END


	SUBROUTINE OBLIQ(XJD,EPSLN)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C:%S COMPUTE THE MEAN OBLIQUITY OF THE ECLIPTIC AND ITS RATE
C:(INPUT SPECIFIES A TIME IN JULIAN DAYS, OUTPUT IS THE
C:OBLIQUITY AND ITS RATE; SEE)
C:COMPUTE THE OBLIQUITY IN REVOLUTIONS PER YEAR FROM ITS TIME EXPANSION/
C:COMPUTE THE RATE OF THE OBLIQUITY IN REVOLUTIONS PER /
C:YEAR FROM ITS TIME EXPANSION
C:CONVERT THE OBLIQUITY TO RADIANS BY MULTIPLYING BY/
C:TWOPI
C:CONVERT THE RATE OF THE OBLIQUITY TO RADIANS PER DAY/
C:BY MULTIPLYING BY TWOPI AND DIVIDING BY 365.25
C
C***NOTE: AS CODED, THIS ROUTINE (FOR COMPATABILITY WITH THE UNIV OF TX LLR
C       ANALYSIS PACKAGE, MAINLY 'SUBLASER') ASSUMES THAT ARBITRARY FIXED
C       EPOCH IS 1950.0 TO CONFORM WITH JPL DE-111 AND EARLIER EPHEMERIDES.
C       AT SUCH TIME THAT EPOCH 2000.0 EPHEMERIDES ARE USED A CHANGE TO T1
C       WILL HAVE TO BE MADE. 
C
C  REVISIONS:
C     04/18/83 -- UPDATE FOR 1976 IAU STANDARD.  RLR
C               LIESKI,ASTRONOMY & ASTROPHYSICS,V.58,P 1. (P. 15)
 
      DOUBLE PRECISION EPSLN(2)

	INCLUDE 'DEFCMN.INC'

	INCLUDE 'DEVCOM.INC'
 
 
      DOUBLE PRECISION JD2000 
 
      COMMON/TWOPI/TWOPI,CDR,CASR,CTSR
 
      DATA JD2000 /2451545.D0/
      DATA TCENT  /36525.D0/
      DATA T1     /2433282.423D0/
 
      T0 = (T1-JD2000)/TCENT
      T  = (XJD-T1)/TCENT
      EPS0 = 84381.448D0
      A0 = ((0.001813D0*T0-0.00059D0)*T0-46.8150D0)*T0
      A1 = (0.005439D0*T0-0.00117D0)*T0-46.8150D0
      A2 = 0.005439D0*T0-0.00059D0
      A3 = 0.001813D0
      EPSLN(1) = (((A3*T+A2)*T+A1)*T+A0+EPS0)*CASR
      EPSLN(2) =  ((3.*A3*T + 2.*A2)*T+A1)/TCENT*CASR
 
      IF (DEB(14)) WRITE(DUNIT,1000) T,EPSLN
 1000 FORMAT(1X,'OBLIQ: T & EPSLN',3E20.10)
      RETURN
C
C	   THE
	   END

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c	SUBROUTINE NUTATE(XNUTLN,XNUTOB,EPSLM,NUTAM)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	SUBROUTINE NUTATE(XNUTLN,XNUTOB,EPSLM,NUTAM)
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  Tue Oct 25, 1988 08:59:33
C     1) REPLACE "COMPILER DOUBLE PRECISION" WITH
C        "IMPLICIT DOUBLE PRECISION (A-H,O-Z)".
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C:%S COMPUTE AUGMENTED ROTATION MATRIX FOR NUTATION
C:(INPUT IS NUTATION IN LONGITUDE AND ITS RATE, NUTATION IN THE
C:OBLIQUITY OF THE ECLIPTIC AND ITS RATE AND THE OBLIQUITY OF
C:THE ECLIPTIC; OUTPUT IS THE NUTATION MATRIX; SEE)
C:CORRECT THE OBLIQUITY OF THE ECLIPTIC FOR THE NUTATION IN THE
C:OBLIQUITY BY ADDING THE TWO
C:CORRECT THE RATE OF THE OBLIQUITY FOR THE NUTATION RATE OF THE
C:OBLIQUITY BY ADDING THE TWO
C:CONSTRUCT AUGMENTED ROTATION MATRIX (NEGATIVE ROTATION THROUGH
C:THE OBLIQUITY ABOUT THE 1 AXIS, ROTATION FLAG TO - 1)
C:CONSTRUCT AUGMENTED ROTATION MATRIX (POSITIVE ROTATION THROUGH 
C:THE NUTATION IN LONGITUDE ABOUT THE 3 AXIS, ROTATION FLAG TO +3)
C:CONSTRUCT AUGMENTED ROTATION MATRIX (POSITIVE ROTATION THROUGH
C:THE NUTATION CORRECTED OBLIQUITY ABOUT THE 1 AXIS, ROTATION FLAG
C:TO +1)
C:MATRIX MULTIPLICATION (PREMULTIPLY OBLIQUITY MATRIX BY THE NUTATION IN
C:LONGITUDE MATRIX)
C:MATRIX MULTIPLICATION (PREMULTIPLY RESULT OF THE PRECEDING MATRIX
C:MULTIPLICATION BY THE NUTATION CORRECTED OBLIQUITY MATRIX)
C
	INCLUDE 'DEFCMN.INC'

	INCLUDE 'DEVCOM.INC'

      DOUBLE PRECISION XNUTLN(2),XNUTOB(2),EPSLM(2)
      DOUBLE PRECISION NUTAM(6,3)
      DOUBLE PRECISION MTRX1(6,3),MTRX2(6,3),MTRX3(6,3),TEMP1(6,3)
      DOUBLE PRECISION EPSLT(2)

      DO 10 I = 1,2
   10 EPSLT(I) = EPSLM(I) + XNUTOB(I)
      CALL ROTMAT(-1,EPSLM,MTRX1)
      CALL ROTMAT(+3,XNUTLN,MTRX2)
      CALL ROTMAT(+1,EPSLT,MTRX3)
      CALL MATMUL(MTRX2,MTRX1,TEMP1,6,3,3)
      CALL MATMUL(MTRX3,TEMP1,NUTAM,6,3,3)

      IF (DEB(15)) WRITE(DUNIT,1000) NUTAM
 1000 FORMAT(1X,'NUTATE: NUTAM ',3(/6(1X,E20.10)))
C
C	   THE
	   END


	SUBROUTINE PRECESS(T1,T2,PRECM)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C:%S COMPUTE AUGMENTED ROTATION MATRIX FOR PRECESSION
C:(COMPUTE PRECESSION MATRIX FROM JULIAN DATE T1 TO JULIAN DATE T2, OUTPUT/
C:IS THE PRECESSION MATRIX; SEE EX. SUPP.)
C:SET THE JULIAN DATE FOR 1900.0 TO 2415020.313516463
C:SET THE NUMBER OF DAYS IN A TROPICAL CENTURY TO 36524.219879
C:COMPUTE THE TIME DIFFERENCE T2 - T1 IN TROPICAL CENTURIES 
C:COMPUTE THE TIME DIFFERENCE T1 - J.D. OF 1900 IN TROPICAL /
C:CENTURIES
C:COMPUTE PRECESSION ELEMENT ZETA FROM NEWCOMBS EXPANSION  /
C:COMPUTE PRECESSION ELEMENT Z FROM NEWCOMBS EXPANSION   /
C:COMPUTE PRECESSION ELEMENT THETA FROM NEWCOMBS EXPANSION  /
C:COMPUTE RATE OF ZETA
C:COMPUTE RATE OF Z 
C:COMPUTE RATE OF THETA
C:CONVERT ZETA, Z AND THETA AND THEIR RATES FROM ARC SECONDS TO /
C:RADIANS 
C:CONSTRUCT AUGMENTED ROTATION MATRIX (POSITIVE ROTATION THROUGH/
C:ZETA ABOUT THE 3 AXIS, ROTATION FLAG TO +3)
C:CONSTRUCT AUGMENTED ROTATION MATRIX (NEGATIVE ROTATION THROUGH /
C:THETA ABOUT THE 2 AXIS, ROTATION FLAG TO - 2)
C:CONSTRUCT AUGMENTED ROTATION MATRIX (POSITIVE ROTATION THROUGH/
C:Z ABOUT THE 3 AXIS, ROTATION FLAG TO +3)
C:MATRIX MULTIPLICATION (PREMULTIPLY ZETA MATRIX BY THETA MATRIX)
C:MATRIX MULTIPLICATION (PREMULTIPLY RESULT OF PRECEDING MATRIX MULTIPLICATION
C:BY Z MATRIX)
C
C  REVISIONS:
C     04/22/83 -- PRECESSION BASED ON THE IAU 1976 SYSTEM OF ASTRONOMICAL
C               CONSTANTS. LIESKE,LEDERLE,FRICKE, AND MORANDO, ASTRONOMY
C               AND ASTROPHYSICS, V 58, PP.1-16 (P.15).  PJS,RLR.
C
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
 
      DOUBLE PRECISION PRECM(6,3)
      DOUBLE PRECISION MTRX1(6,3),MTRX2(6,3),MTRX3(6,3),TEMP1(6,3)
      DOUBLE PRECISION ZETA0(2),THETA(2),Z(2)
      DOUBLE PRECISION JD2000 

	INCLUDE 'DEFCMN.INC'

	INCLUDE 'DEVCOM.INC'

      COMMON/TWOPI/TWOPI,CDR,CASR,CTSR
      DATA JD2000/2451545.D0/ 
      DATA TCENT/36525.D0/
 
      T0 = (T1 - JD2000)/TCENT
      T = (T2 - T1)/TCENT
      A1 = (-0.000139D0*T0+1.39656D0)*T0+2306.2181D0
      A2 = 0.30188D0-0.000345D0*T0
      A3 = 0.017998D0 
      B1 = A1
      B2 = 1.09468D0+0.000066D0*T0
      B3 = 0.018203D0 
      C1 = (-0.000217D0*T0-0.85330D0)*T0+2004.3109D0
      C2 = -0.42665D0-0.000217D0*T0
      C3 = -0.041833D0
      ZETA0(1) = (((A3*T + A2)*T + A1)*T)*CASR
      Z(1)     = (((B3*T + B2)*T + B1)*T)*CASR
      THETA(1) = (((C3*T + C2)*T + C1)*T)*CASR
      ZETA0(2) = ((3*A3*T + 2*A2)*T + A1)/TCENT*CASR
      Z(2)     = ((3*B3*T + 2*B2)*T + B1)/TCENT*CASR
      THETA(2) = ((3*C3*T + 2*C3)*T + C1)/TCENT*CASR
      CALL ROTMAT(+3,ZETA0,MTRX1)
      CALL ROTMAT(-2,THETA,MTRX2)
      CALL ROTMAT(+3,Z,    MTRX3)
      CALL MATMUL(MTRX2,MTRX1,TEMP1,6,3,3)
      CALL MATMUL(MTRX3,TEMP1,PRECM,6,3,3)
 
      IF (DEB(16)) WRITE(DUNIT,1000) T1,T2,PRECM
 1000 FORMAT(1X,'PRECESS: T1,T2,PRECM',2E20.10, 3(/6(1X,E20.10)))
      RETURN
C
C	   THE
	   END


	SUBROUTINE MATADD(A,B,C,NROW)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C     ADD MATRICES A AND B WITH RESULTS IN MATRIX C
C     NROW = NUMBER OF ROWS OF MATRICES A, B AND C
C     NCOL = NUMBER OF COLUMNS OF MATRICES A, B AND C
      DOUBLE PRECISION A(6),B(6),C(6)
      DO 250 I=1,NROW
      C(I)=A(I) + B(I)
  250 CONTINUE
      RETURN
C
C	   THE
	   END


	SUBROUTINE MATMUL(A,B,C,NROWS,NCOLA,NCOLB)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION A(6,3),B(6,3),C(6,3)
      DOUBLE PRECISION P(3,3),V(3,3)
C
      NRW2=NROWS/2
      IMAX=NRW2
      JMAX=NCOLB
      KMAX=NCOLA
C
      DO 30 J=1,JMAX
      DO 30 I=1,IMAX
      P(I,J)=0.0
      V(I,J)=0.0
      DO 30 K=1,KMAX
      M1=I
      M2=K
      M3=K
      M4=J
      P(I,J)=P(I,J) + A(M1,M2)*B(M3,M4) 
      V(I,J)=V(I,J) + A(M1,M2)*B(M3+3,M4) + A(M1+3,M2)*B(M3,M4)
   30 CONTINUE
      DO 40 J=1,JMAX
      DO 40 I=1,IMAX
      C(I,J)=P(I,J) 
   40 C(I+3,J)=V(I,J)
      RETURN
C
C	   THE
	   END


	SUBROUTINE MATTRNS(A,NROW,NCOL)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C.....COMPUTE TRANSPOSE OF AN AUGMENTED MATRIX
      DOUBLE PRECISION A(6,3),B(3,3)
C.....FIRST POSITIONS
      NRW2=NROW/2
      NRW2P1=NRW2 + 1
      DO 250 I=1,NRW2
      DO 200 J=1,NCOL
      B(J,I)=A(I,J) 
  200 CONTINUE
  250 CONTINUE
      DO 450 I=1,NRW2
      DO 400 J=1,NCOL
      A(I,J)=B(I,J) 
  400 CONTINUE
  450 CONTINUE
C.....THEN VELOCITIES
      DO 650 I=1,NRW2
      DO 600 J=1,NCOL
      B(J,I)=A(I+NRW2,J)
  600 CONTINUE
  650 CONTINUE
      DO 850 I=1,NRW2
      DO 800 J=1,NCOL
      A(I+NRW2,J)=B(I,J)
  800 CONTINUE
  850 CONTINUE
      RETURN
C
C	   THE
	   END


	SUBROUTINE RAMSUN(XJD,RAMSN)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C:%S COMPUTE THE RIGHT ASCENSION OF THE MEAN SUN AND ITS RATE
C:(INPUT SPECIFIES A TIME IN JULIAN DAYS, OUTPUT IS THE /
C:RIGHT ASCENSION OF THE MEAN SUN AND ITS RATE; SEE EX. SUPP.)
C:COMPUTE THE RIGHT ASCENSION IN REVOLUTIONS FROM ITS EXPANSION
C:MODULAR FUNCTION (THE RIGHT ASCENSION TO BETWEEN THE INTERVAL OF /
C:0 TO 1 REVOLUTIONS)
C:IF THE RIGHT ASCENSION IS LESS THAN 0.0
C:ADD ONE REVOLUTION TO THE RIGHT ASCENSION
C:ENDIF
C:CONVERT THE RIGHT ASCENSION TO RADIANS BY MULTIPLYING/
C:BY TWOPI
C:COMPUTE THE RATE OF THE RIGHT ASCENSION IN REVOLUTIONS/
C:PER ? FROM ITS EXPANSION
C:CONVERT THE RATE OF THE RIGHT ASCENSION TO RADIANS/
C:PER ? BY MULTIPLYING BY TWOPI
C  REVISIONS:
C     05/02/83 - NEW IAU '76 SIDEREAL TIME SERIES 
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
      DOUBLE PRECISION RAMSN(2)

	INCLUDE 'DEFCMN.INC'

	INCLUDE 'DEVCOM.INC'

      COMMON/TWOPI/TWOPI,CDR,CASR,CTSR
      DATA A0 / 7.790572732638889D-01/
      DATA A1 / 1.00002139037801 D+02/
      DATA A2 / 1.077592593      D-06/
      DATA A3 /-7.176            D-11/
      DATA B1 / 2.73790935079537 D-03/
      DATA B2 / 5.900575         D-11/
      DATA B3 /-5.894            D-15/
 
      T = (XJD - 2451545.D0)/36525.D0
      Y = DMOD((((A3*T + A2)*T + A1)*T + A0), 1.0D0)
      IF (Y) 5,10,10
    5 Y = Y +1.0D0
   10 RAMSN(1) = Y*TWOPI
      RAMSN(2) = ((B3*T + B2)*T + B1)*TWOPI
 
      IF (DEB(17)) WRITE(DUNIT,1000) XJD,RAMSN
 1000 FORMAT(1X,'RAMSUN: XJD & RAMSN',3E20.10)
      RETURN
C
C	   THE
	   END


      SUBROUTINE ROTMAT(KAXIS,A,R)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C:%S CONSTRUCT AUGMENTED ROTATION MATRIX
C:(INPUT IS ROTATION FLAG, ANGLE AND ANGLE RATE; OUTPUT IS ROTATION/
C:MATRIX)
C:INITIALIZE 6X3 ROTATION MATRIX TO ZERO
C:IF ROTATION FLAG IS NEGATIVE
C:MULTIPLY ANGLE BY - 1
C:MULTIPLY ANGLE RATE BY - 1
C:ENDIF
C:COMPUTE SIN ANGLE
C:COMPUTE COS ANGLE
C:MULTIPLY ANGLE RATE BY SIN ANGLE
C:MULTIPLY ANGLE RATE BY COS ANGLE
C:IF ABSOLUTE VALUE OF ROTATION FLAG EQUAL TO 1
C:(MATRIX FOR ROTATION ABOUT THE 1 AXIS)
C:SET 1,1 ELEMENT TO 1.0
C:SET 2,2 ELEMENT TO COS ANGLE
C:SET 2,3 ELEMENT TO - SIN ANGLE
C:SET 3,2 ELEMENT TO SIN ANGLE
C:SET 3,3 ELEMENT TO COS ANGLE
C:SET 5,2 ELEMENT TO - ANGLE RATE X SIN ANGLE
C:SET 5,3 ELEMENT TO - ANGLE RATE X COS ANGLE
C:SET 6,2 ELEMENT TO ANGLE RATE X COS ANGLE
C:SET 6,3 ELEMENT TO - ANGLE RATE X SIN ANGLE
C:ELSEIF ABSOLUTE VALUE OF ROTATION FLAG EQUAL TO 2
C:(MATRIX FOR ROTATION ABOUT THE 2 AXIS)
C:SET 2,2 ELEMENT TO 1.0
C:SET 1,1 ELEMENT TO COS ANGLE
C:SET 1,3 ELEMENT TO SIN ANGLE
C:SET 3,1 ELEMENT TO - SIN ANGLE
C:SET 3,3 ELEMENT TO COS ANGLE
C:SET 4,1 ELEMENT TO - ANGLE RATE X SIN ANGLE
C:SET 4,3 ELEMENT TO ANGLE RATE X COS ANGLE
C:SET 6,1 ELEMENT TO - ANGLE RATE X COS ANGLE
C:SET 6,2 ELEMENT TO - ANGLE RATE X SIN ANGLE
C:ELSE
C:(MATRIX FOR ROTATION ABOUT THE 3 AXIS)
C:SET 3,3 ELEMENT TO 1.0
C:SET 1,1 ELEMENT TO COS ANGLE
C:SET 1,2 ELEMENT TO - SIN ANGLE
C:SET 2,1 ELEMENT TO SIN ANGLE
C:SET 2,2 ELEMENT TO COS ANGLE
C:SET 4,1 ELEMENT TO - ANGLE RATE X SIN ANGLE
C:SET 4,2 ELEMENT TO - ANGLE RATE X COS ANGLE
C:SET 5,1 ELEMENT TO ANGLE RATE X COS ANGLE
C:SET 5,2 ELEMENT TO - ANGLE RATE X SIN ANGLE
C:ENDIF
C  Revisions:
C	11/22/88 - condense the program by recognizing
c		   patterns in rotations. v01. rlr.
C
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c 21 Sep 90, 0935: use d.p. constants; use d.p. functions dsin, dcos
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      DIMENSION R(6,3),A(2)
      
      DO 1 J = 1,6
      DO 1 I = 1,3
    1 R(J,I) = 0.0d0
    
      K= IABS(KAXIS)
      IONE= K/KAXIS
      A1= IONE*A(1)
      ADOT= IONE*A(2)
      
      SINA = dSIN(A1)
      COSA = dCOS(A1)
      ADSINA = ADOT*SINA
      ADCOSA = ADOT*COSA

      KP1= MOD(K,3)+ 1
      KP2= MOD(KP1,3)+ 1
      R(K,K)= 1.0d0
      R(KP1,KP1)= COSA
      R(KP1,KP2)= -SINA
      R(KP2,KP1)= SINA
      R(KP2,KP2)= COSA
      R(KP1+3,KP1)= -ADSINA
      R(KP1+3,KP2)= -ADCOSA
      R(KP2+3,KP1)= ADCOSA
      R(KP2+3,KP2)= -ADSINA
c
c	   the
	   end


	SUBROUTINE LIBRATE(JD,RM)
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  Tue Oct 25, 1988 10:30:11
C     1) REPLACE "COMPILER DOUBLE PRECISION" WITH
C        "IMPLICIT DOUBLE PRECISION (A-H,O-Z)".
C     2) MAKE SURE STATEMENTS DON'T EXTEND BEYOND COLUMN 72.
C     3) REMOVE IN-LINE COMMENTS.
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  Wed Nov 2, 1988 10:06:54
C     1) MOVE COMMON BLOCK /DDMU1/ AND ASSOCIATED DATA
C        STATEMENTS TO EULCOMNP.FOR
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  Fri Mar 31, 1989 14:11:27
C     REPLACE: "SIN" <- "DSIN", "COS" <- "DCOS"
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  THIS SUBROUTINE COMPUTES THE LUNAR LIBRATION ROTATION MATRIX
C  RM USING THE INFORMATION CONTAINED IN COMMON BLOCKS FUNBLK AND LIB.
C  THE INFORMATION IN COMMON BLOCK LIB HAS BEEN LOADED DURING THE
C  MOST RECENT CALL TO THE MIT VERSION OF THE READE PACKAGE. THE
C  INFORMATION IN THE COMMON BLOCK HAS BEEN LOADED DURING THE MOST
C  RECENT CALL TO SUBROUTINE FUNARG.
C	MIT NUMERICAL LIBRATIONS USED
C
C  REVISIONS:
C	07/18/87 - HANDLE OVERLAYS TO GET TO OBLIQ ROUTINE. V01. RLR.
C
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

      DOUBLE PRECISION JD,E
      DOUBLE PRECISION RM(6,3)
      DOUBLE PRECISION TWOPI,CDR,CASR,CTSR
      DOUBLE PRECISION RMX(3,3),SA(3,3),SB(3,3),EPSLM(2)

      COMMON /TWOPI/TWOPI,CDR,CASR,CTSR

	INCLUDE 'DDMU1.INC'

	INCLUDE 'DEFCMN.INC'

	INCLUDE 'DEVCOM.INC'

	INCLUDE 'LIB.INC'

	INCLUDE 'FUNBLK.INC'

C
C  CALCULATE FUNDAMENTAL AGUMENTS & PUT INTO /FUNBLK/
c		JULIAN CENTURIES SINCE 1900.
      E= (JD- 2415020.D0)/36525.D0
      CALL FUNARG(E)

      DO 100 I=1,6
      DO 100 J=1,3
  100 RM(I,J)=0.0D0

C  CONVERT TAU,RHO,I*(TAU-SIGMA) -> TAU,THETA,SIGMA (LIBR(1),T,S)
      T = LIBR(2) + MEQI
      S = LIBR(1) - LIBR(3)/MEQI
  
      CALL OBLIQ(JD,EPSLM)
      SEBAR = DSIN(EPSLM(1))
      CEBAR = DCOS(EPSLM(1))
      X1(2,2) = CEBAR
      X1(2,3) = SEBAR
      X1(3,2) = -SEBAR
      X1(3,3) = CEBAR

      SNODE = DSIN(EOM+S)
      CNODE = DCOS(EOM+S)
      Z2(1,1) = CNODE
      Z2(1,2) = SNODE
      Z2(2,1) = -SNODE
      Z2(2,2) = CNODE

      SEQUI = DSIN(T)
      CEQUI = DCOS(T)
      X3(2,2) = CEQUI
      X3(2,3) = -SEQUI
      X3(3,2) = SEQUI
      X3(3,3) = CEQUI

      STLUN = DSIN(ELM+LIBR(1)-EOM-S+TWOPI*0.5D0)
      CTLUN = DCOS(ELM+LIBR(1)-EOM-S+TWOPI*0.5D0)
      Z4(1,1) = CTLUN
      Z4(1,2) = STLUN
      Z4(2,1) = -STLUN
      Z4(2,2) = CTLUN

      CALL MATMPY(Z2,X1,SA,3,3)
      CALL MATMPY(X3,SA,SB,3,3)
      CALL MATMPY(Z4,SB,RMX,3,3)
C
      DO 32 I=1,3
      DO 32 J=1,3
   32 RM(I,J) = RMX(J,I)
C
      IF (DEB(20)) WRITE(DUNIT,1000) MEQI,LIBR,T,S
 1000 FORMAT(1X,"LIBR: INCL,TAU,RHO,I*(TAU-SIGMA),THETA,SIGMA: ",/,
     1		1X,6E20.12)
C
C	   THE
	   END


      SUBROUTINE MATMPY(A,B,C,NROW,NCOL)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C     PREMULTIPLY MATRIX B BY MATRIX A WITH RESULTS IN MATRIX C
C     NROW = NUMBER OF ROWS OF MATRIX A
C     NCOL = NUMBER OF COLUMNS OF MATRIX BS
C
C  REVISIONS:
C	01/15/89 - FIX FOR 3X3 TIMES 3X1 CASE
      DIMENSION A(3,3),B(3,3),C(3,3)
      DO 250 I=1,NROW
      DO 200 J=1,NCOL
      SUM=0.0
      DO 150 N=1,NROW
      SUM=SUM + A(I,N)*B(N,J)
  150 CONTINUE
      C(I,J)=SUM
  200 CONTINUE
  250 CONTINUE
      RETURN 
      END


	SUBROUTINE FUNARG(E)
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  Tue Oct 25, 1988 08:20:09
C     1) REPLACE "COMPILER DOUBLE PRECISION" WITH
C        "IMPLICIT DOUBLE PRECISION (A-H,O-Z)".
C     2) MAKE SURE STATEMENTS DON'T EXTEND BEYOND COLUMN 72.
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  Wed Nov 2, 1988 10:51:55
C     1) MOVE /FALOOK/ DATA STETEMENTS TO "BLKNP.FOR".
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  Wed Mar 29, 1989 09:26:17
C     1) KLUDGE D.P. RELATIONAL EXPRESSIONS.
C  Wed May 31, 1989 14:00:42
C     1) REMOVE KLUDGE.
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     COMPUTE FUNDAMENTAL ARGUMENTS FOR TIME -E- IN JULIAN CENTURIES
C                  FROM 2415020.0 (1900)
      COMMON /TWOPI/TWOPI,CDR,CASR,CTSR

	INCLUDE 'DEFCMN.INC'

	INCLUDE 'DEVCOM.INC'

	INCLUDE 'FUNBLK.INC'

      COMMON /FALOOK/ FA(26)

C     NOTATION -- LET -X- REPRESENT -S- FOR SUN, -M- FOR MOON.
C     THEN ELX = MEAN LONGITUDE,
C          EGX = MEAN LONGITUDE OF PERIGEE,
C          EOX = MEAN LONGITUDE OF ASCENDING NODE,
C          EMX = MEAN ANOMALY = ELX - EGX.
C     F = ARGUMENT OF LATITUDE OF MOON = ELM - EOM.
C     D = MEAN ELONGATION OF MOON FROM SUN = ELM - ELS.
C     EPS = MEAN OBLIQUITY OF ECLIPTIC.
C     ECS = MEAN ECCENTRICITY OF SUN.
C     -V- CONVERTS SECONDS OF ARC TO RADIANS.
      V = CASR
      CCS=V/3.15576D+09
      E2=E+E
      E3=(E2+E)*0.5D0
      XEMM = V*(FA(1)+E*(FA(2)+E*(FA(3)+E*(FA(4)))))
      EMM=DMOD(XEMM,TWOPI)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
	IF (DEB(7))WRITE(DUNIT,5901)E,V,(FA(I),I=1,4),
     1		XEMM,TWOPI,EMM
5901	FORMAT(' FUNARG:',2(1X,D13.6),/,
     1		4(1X,D13.6),/,3(1X,D13.6))
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      EMMDOT=CCS*(FA(2)+E2*(FA(3)+E3*FA(4)))
      EMS = V*(FA(5)+E*(FA(6)+E*(FA(7)+E*(FA(8)))))
      EMS=DMOD(EMS,TWOPI)
      EMSDOT=CCS*(FA(6)+E2*(FA(7)+E3*FA(8)))
      F = V*(FA(9)+E*(FA(10)+E*(FA(11)+E*(FA(12)))))
      F=DMOD(F,TWOPI)
      FDOT=CCS*(FA(10)+E2*(FA(11)+E3*FA(12)))
      D = V*(FA(13)+E*(FA(14)+E*(FA(15)+E*(FA(16)))))
      D=DMOD(D,TWOPI)
      DDOT=CCS*(FA(14)+E2*(FA(15)+E3*FA(16)))
      EOM = V*(FA(17)+E*(FA(18)+E*(FA(19)+E*(FA(20)))))
      EOM=DMOD(EOM,TWOPI)
      EOMDOT=CCS*(FA(18)+E2*(FA(19)+E3*FA(20)))
      ELM=F+EOM
	IF (ELM.GT.TWOPI) ELM=ELM-TWOPI
      ELMDOT=FDOT+EOMDOT
      ELS=ELM-D
      IF (ELS.LT.0.D0) ELS=ELS+TWOPI
      ELSDOT=ELMDOT-DDOT
      EGS=ELS-EMS
      IF (EGS.LT.0.D0) EGS=EGS+TWOPI
      EGSDOT=ELSDOT-EMSDOT
      EGM=ELM-EMM
      IF (EGM.LT.0.D0) EGM=EGM+TWOPI
      EGMDOT=ELMDOT-EMMDOT
      EPS = V*(FA(21)+E*(FA(22)+E*(FA(23)+E*(FA(24)))))
      EPS=DMOD(EPS,TWOPI)
      EPSDOT=CCS*(FA(22)+E2*(FA(23)+E3*FA(24)))
C     N.B. BROWN*S VALUE, NOT NEWCOMB*S, IS USED FOR ECS.
      ECS = FA(25)+E*(FA(26))
      ECS=DMOD(ECS,TWOPI)
      ECSDOT=FA(26)/3.15576D+09

 100  IF (DEB(7)) WRITE(DUNIT,1000) ELM,EGM,EOM,EMM,F,ELS,
     1		EGS,EMS,D,EPS,ECS,
     2		ELMDOT,EGMDOT,EOMDOT,EMMDOT,FDOT,ELSDOT,EGSDOT,
     3		EMSDOT,DDOT,EPSDOT,ECSDOT
 1000 FORMAT(' FUNARG: ',4E20.10,3(/1X,6E20.10))
C
C	   THE
	   END


	SUBROUTINE OUTLEG(TJDINT,SUTCT,BODRFL,ITERMX,
     $		EMUTC,RK2MC3,VLITE,TOLERR,DTNEW,DIST12,CORR12,SUTCB)
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  Tue Oct 25, 1988 10:48:26
C     1) REPLACE "COMPILER DOUBLE PRECISION" WITH
C        "IMPLICIT DOUBLE PRECISION (A-H,O-Z)".
C     2) MAKE SURE STATEMENTS DON'T EXTEND BEYOND COLUMN 72.
C     3) REMOVE IN-LINE COMMENTS.
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
c 02 May 90, 1629- remove unused formal parameters beta, gamma.
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C 08 Mar 91, 1511: change "stop" to "call error:
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C:%S OUT BOUNCE ITERATION
C:(INPUT: JULIAN DATE, DYNAMICAL MINUS UTC CLOCK CORRECTION THROUGH
C:COMMON (FOR THE EPHEMERIS AND ALSO THE LIBRATIONS) AND THE
C:HELIOCENTRIC EPHEMERIS STATE VECTOR OF THE TRANSMITTER; OUTPUT:
C:OUT BOUNCE LEG DISTANCE IN AU, THE TRANSMITTER TO REFLECTOR STATE
C:VECTOR IN THE SYSTEM OF THE EPHEMERIS AND THE HELIOCENTRIC
C:EPHEMERIS STATE VECTOR OF THE REFLECTOR)
C:INITIALIZE OUT BOUNCE ITERATION COUNTER TO 0
C:INITIALIZE CONVERGENCE FLAG TO FALSE
C:DO WHILE ITERATION COUNTER LESS THAN AN INPUT VALUE
C:INCREMENT OUT BOUNCE ITERATION COUNTER BY 1
C:IF OUT BOUNCE ITERATION COUNTER IS 1
C:SET FIRST ESTIMATE OF LIGHT TRAVEL TIME OF LEG TO ZERO
C:ELSE
C:PERFORM STEP OF LIGHT TRAVEL TIME ITERATION (COMPUTE
C:ITERATED VALUE OF THE LIGHT TRAVEL TIME AND SET FLAG TO TRUE IF
C:ITERATION HAS CONVERGED)
C:IF CONVERGENCE FLAG
C:UNDO
C:ENDIF
C:ENDIF
C:COMPUTE BOTH THE DYNAMICAL AND UTC TIME OF BOUNCE AT THE REFLECTOR
C:BY ADDING THE CURRENT LIGHT TRAVEL TIME ESTIMATE OF THE
C:LEG TO THE DYNAMICAL AND UTC TIME, RESPECTIVELY, AT WHICH LIGHT
C:LEAVES THE TRANSMITTER
C:EPHEMERIS READ (OBTAIN THE HELIOCENTRIC EPHEMERIS STATE VECTOR
C:OF THE MOON AT BOUNCE TIME)
C:IF NOT ERROR WHILE EPHEMERIS READ
C:COMPUTE THE LIBRATION ROTATION MATRIX [E] (TO TRANSFORM FROM THE
C:MOON FIXED ROTATION AXIS TO THE MEAN
C:OF DATE SYSTEM)
C:MATRIX MULTIPLICATION (LIBRATE THE REFLECTOR STATE VECTOR FROM THE
C:BODY FIXED SYSTEM TO THE MEAN EQUATORIAL OF DATE SYSTEM BY
C:MULTIPLYING THE CURRENT REFLECTOR STATE VECTOR BY MATRIX [E])
C:MATRIX MULTIPLICATION (PRECESS THE REFLECTOR STATE VECTOR FROM
C:THE MEAN OF DATE TO THE EPHEMERIS EPOCH SYSTEM BY MULTIPLYING THE
C:CURRENT REFLECTOR STATE VECTOR BY PRECESSION MATRIX [P])
C:MATRIX ADDITION (TRANSLATE THE REFLECTOR STATE VECTOR FROM
C:A SELENOCENTRIC TO A HELIOCENTRIC SYSTEM BY ADDING THE CURRENT
C:STATE VECTOR OF THE REFLECTOR TO THE HELIOCENTRIC EPHEMERIS
C:STATE VECTOR OF THE MOON)
C:ELSE CALL READ ERROR ROUTINE; STOP
C:ENDIF
C:ENDDO
C:IF ITERATION COUNTER GREATER THAN OR EQUAL TO INPUT VALUE
C:PRINT ERROR MESSAGE; STOP
C:ENDIF
C
C  REVISIONS:
C	10/25/84 - INSTALL /PDCMN/ TO ALLOW ITERATING BACKWARDS THRU TIME
C	12/--/85 - ADD CALL TO RE-LOAD INITPKG
C	07/21/87 - COMBINE NP & PREDICT VERSIONS. V02. RLR.
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

      DOUBLE PRECISION LIBMAT(6,3),BODRFL(6),CELRFL(6)
      DOUBLE PRECISION EPHRFL(6),SMVEC(6)
      LOGICAL CONVRG

	INCLUDE 'MODEOP.INC'

	INCLUDE 'EPHREC.INC'

	INCLUDE 'PDCMN.INC'

	INCLUDE 'DEFCMN.INC'

	INCLUDE 'DEVCOM.INC'

	INCLUDE 'CETB4.INC'

	INCLUDE 'BOUNCE.INC'

	INCLUDE 'CETB2.INC'

	INCLUDE 'PRMAT.INC'

C---------------------------------------------------

      ITER=0
      CONVRG=.FALSE.
      DO 150 II=1,ITERMX
      ITER=ITER + 1
      IF (ITER.NE.1) GO TO 25
      SUTCB=SUTCT + ITERDIR*DTNEW*86400.D0
      GO TO 50
   25 CALL LITITER(STVEC,SRFVEC,TRFVEC,RK2MC3,VLITE,TOLERR,
     $ DTOLD,DTNEW,DIST12,CORR12,CONVRG)
      SUTCB=SUTCT + ITERDIR*DTNEW*86400.D0
      IF (DEB(4)) WRITE(DUNIT,1500) ITER,DIST12,CORR12,SECEPHB,
     X        BJDEPH,SMVEC,LIBMAT,CELRFL,EPHRFL,SRFVEC
 1500 FORMAT(1X,'OUTLEG: ITER,DIST12,CORR12,SECEPHB,BJDEPH'/,
     1		I2,1X,4E20.12/
     X     ' MOON: '/ 2(1X,3E22.14/) ' LIBRATIONS: ',(3(/1X,6E20.12))/
     X     ' CELRFL,EPHRFL,SRFVEC:',2(/1X,6E20.12),2(/1X,3E22.14))
      IF (CONVRG) GO TO 175
   50 DTOLD=DTNEW
      IREQ(11)=2
      SECEPHB=SUTCB + EMUTC
      IERR = 0
      CALL READE(TJDINT,SECEPHB,IERR)
      IF (IERR.EQ.0) GO TO 100
ccc      WRITE (ierrout,1000) IERR
ccc 1000 FORMAT (5X,"IN OUTLEG, ERROR WHILE EPHEMERIS READ",1X,I3/,7X,
ccc     1	"INPUT TIME IS (1)EARLIER THAN, (2)LATER THAN EPHEMERIS")
ccc	STOP
	if(ierr .EQ. 1) then
	  errmsg=' OUTLEG: input time earlier than ephemeris.'
	elseif(ierr .EQ. 2) then
	  errmsg=' OUTLEG: input time later than ephemeris.'
	else
	  errmsg=' OUTLEG: bad error code from READE.'
	endif
	call error(5,errmsg,ierr,ierr)
100	CONTINUE
      DO 125 J=1,6
      SMVEC(J)=TABOUT(J,11)
  125 CONTINUE
      IREQ(11)=0
      BJDEPH=TJDINT + SECEPHB/86400.D0
      CALL LIBRATE(BJDEPH,LIBMAT)
C		DON'T BOTHER TO SAVE IT FOR NP & RECAL
      IF (MODEOP.GE.0) GO TO 140
      K=3
      DO 130 I=1,3
      DO 130 J=1,3
      K=K+1
  130 RECD(K)=LIBMAT(J,I)
  140 CALL MATMUL(LIBMAT,BODRFL,CELRFL,6,3,1)
      CALL MATMUL(PRECM,CELRFL,EPHRFL,6,3,1)
      CALL MATADD(SMVEC,EPHRFL,SRFVEC,6)
  150 CONTINUE

  175 CONTINUE
      IF (ITER.LT.ITERMX) GO TO 200
ccc      WRITE (ierrout,2000)
ccc 2000 FORMAT (5X,"OUT LEG NOT CONVERGED")
ccc      STOP 
	errmsg=' OUTLEG: not converged.'
	call error(5,errmsg,0,0)
200	CONTINUE
C
C	   THE
	   END


	SUBROUTINE BAKLEG(TJDINT,SUTCB,BODRCV,ITERMX,UT1C,EMUTC,
     $ DEPS,DPSI,RK2MC3,VLITE,TOLERR,RDT12,DIST23,CORR23)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c 08 Mar 91, 1514: change "stop" to "call error"
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C:%S BOUNCE RETURN ITERATION
C:(INPUT: JULIAN DATE, DYNAMICAL MINUS UTC CLOCK CORRECTION THROUGH/
C:COMMON (FOR THE EPHEMERIS) AND THE HELIOCENTRIC STATE VECTOR OF THE/
C:REFLECTOR; OUTPUT: BOUNCE RETURN LEG DISTANCE IN AU AND THE /
C:REFLECTOR TO RECEIVER STATE VECTOR IN THE SYSTEM OF THE EPHEMERIS)
C:INITIALIZE BOUNCE RETURN ITERATION COUNTER TO 0 
C:INITIALIZE CONVERGENCE FLAG TO FALSE
C:DO WHILE ITERATION COUNTER LESS THAN AN INPUT VALUE
C:INCREMENT BOUNCE RETURN ITERATION COUNTER BY 1
C:IF BOUNCE RETURN ITERATION COUNTER IS 1
C:SET FIRST ESTIMATE LIGHT TRAVEL TIME TO VALUE FOR OUT BOUNCE LEG
C:ELSE
C:PERFORM STEP OF LIGHT TRAVEL TIME ITERATION (COMPUTE /
C:ITERATED VALUE OF THE LIGHT TRAVEL TIME AND SET FLAG TO TRUE IF /
C:ITERATION HAS CONVERGED)
C:IF CONVERGENCE FLAG
C:UNDO
C:ENDIF
C:ENDIF
C:COMPUTE THE TIME AT WHICH LIGHT RETURNS TO THE RECEIVING /
C:TELESCOPE BY ADDING THE CURRENT LIGHT TRAVEL TIME ESTIMATE /
C:OF THE LEG TO THE TIME AT WHICH LIGHT LEAVES THE BOUNCE POINT
C:COMPUTE HELIOCENTRIC EPHEMERIS STATE VECTOR OF THE TELESCOPE (AT /
C:RETURN TIME)
C:ENDDO
C:IF ITERATION COUNTER GREATER THAN OR EQUAL TO INPUT VALUE 
C:PRINT ERROR MESSAGE; STOP
C:ENDIF

	INCLUDE 'BOUNCE.INC'

	INCLUDE 'DEFCMN.INC'

	INCLUDE 'DEVCOM.INC'

	INCLUDE 'DIRCTN.INC'

	INCLUDE 'PDCMN.INC'

      DOUBLE PRECISION BODRCV(6)
      LOGICAL CONVRG

C------------------------------------------------

      ITER=0
      CONVRG=.FALSE.
      DO 150 I=1,ITERMX
      ITER=ITER+1
      IF (ITER.NE.1) GO TO 25 
      DTNEW=RDT12
      SUTCR=SUTCB + ITERDIR*DTNEW*86400.D0      
      RJDUTC=TJDINT + SUTCR/86400.D0
      GO TO 50
   25 CALL LITITER(SRFVEC,SRVEC,RFRVEC,RK2MC3,VLITE,TOLERR,DTOLD,DTNEW,
     $ DIST23,CORR23,CONVRG)
      SUTCR=SUTCB + ITERDIR*DTNEW*86400.D0      
      RJDUTC=TJDINT + SUTCR/86400.D0
      IF (DEB(5))
     $    WRITE(DUNIT,1200) ITER,DIST23,CORR23,SUTCR,RJDUTC,DTNEW
 1200 FORMAT(' BAKLEG: ITER,DIST23,CORR23,SUTCR,RJDUTC,DTNEW'/
     $       1X,I2,1X,5E20.12)
      IF (CONVRG) GO TO 175
   50 DTOLD=DTNEW
      LEGDIR=2
      CALL EPHTEL(TJDINT,SUTCR,BODRCV,UT1C,EMUTC,DEPS,DPSI,SRVEC)
  150 CONTINUE
 
  175 CONTINUE
      IF (ITER.LT.ITERMX) GO TO 200
ccc      WRITE (ierrout,2000)
ccc 2000 FORMAT (5X,'BACK LEG NOT CONVERGED')
ccc      STOP
	errmsg=' BACKLEG: not converged.'
	call error(5,errmsg,0,0)
200	CONTINUE
C
C	   THE
	   END


	SUBROUTINE LITITER(PVA,PVB,PVAB,K2MC3,VLITE,TOLERR,
     $ DTOLD,DTNEW,DSTAB,CORR,CONVRG)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  Wed Mar 29, 1989 09:27:41
C     1) KLUDGE D.P. RELATIONAL EXPRESSIONS.
C  Wed May 31, 1989 14:02:49
C     1) REMOVE KLUDGE.
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C:%S PERFORM STEP OF LIGHT TRAVEL TIME ITERATION
C:COMPUTE THE STATE VECTOR DIFFERENCE BETWEEN THE BEGIN AND END /
C:LEG POINTS BY THE SUBTRACTION OF THEIR HELIOCENTRIC STATE VECTORS
C:COMPUTE THE NEWTONIAN LENGTH BETWEEN THE BEGIN AND END LEG POINTS
C:COMPUTE THE HELIOCENTRIC DISTANCES OF THE BEGIN AND END LEG POINTS
C:COMPUTE LIGHT TIME CORRECTION IN DAYS FOR GEODESIC CURVATURE FOR /
C:THE LEG (AS DETERMINED BY THE HELIOCENTRIC DISTANCES OF THE BEGIN / 
C:AND END LEG POINTS, THE LEG DISTANCE AND A CONSTANT; SEE         /
C:FOR REFERENCE)
C:DIVIDE THE LEG DISTANCE BY THE VELOCITY OF LIGHT, WHICH IS IN UNITS/
C:OF A.U. PER DAY, TO OBTAIN THE LIGHT TRAVEL TIME IN DAYS
C:ADD THE GEODESIC CURVATURE CORRECTION TO THE LIGHT TRAVEL TIME
C:COMPUTE THE DIFFERENCE BETWEEN CURRENT ITERATED LIGHT TRAVEL TIME / 
C:OF THE LEG AND THAT OF THE PREVIOUS ITERATION
C:IF THE DIFFERENCE BETWEEN THE CURRENT AND PREVIOUS LIGHT TRAVEL TIME/
C:ESTIMATES IS LESS THAN OR EQUAL TO A TOLERANCE
C:SET CONVERGENCE FLAG TO TRUE (FOR CONVERGENCE)
C:ELSE
C:COMPUTE THE TIME DERIVATIVE OF THE DISTANCE BETWEEN THE BEGIN AND / 
C:END LEG POINTS (AS DETERMINED BY THE DOT PRODUCT OF THE POSITION /
C:VECTOR AND THE VELOCITY VECTOR DIVIDED BY THE DISTANCE)
C:SUBTRACT FROM THE VELOCITY OF LIGHT THE TIME DERIVATIVE OF THE /
C:DISTANCE BETWEEN THE BEGIN AND END LEG POINTS AND DIVIDE THE RESULT/
C:INTO THE VELOCITY OF LIGHT (THIS CORRECTS THE VELOCITY OF LIGHT TO /
C:CONSIDER THE RELATIVE MOTION OF THE BEGIN AND END POINTS)
C:MULTIPLY THE CORRECTED LIGHT VELOCITY BY THE DIFFERENCE BETWEEN THE/
C:CURRENT AND PREVIOUS LIGHT TRAVEL TIME ESTIMATES AND ADD TO THE /
C:PREVIOUS LIGHT TRAVEL TIME ESTIMATE
C:ENDIF
      DOUBLE PRECISION K2MC3
      DOUBLE PRECISION PVA(6),PVB(6),PVAB(6)
      LOGICAL CONVRG
      DO 25 I=1,6
      PVAB(I)=PVB(I) - PVA(I) 
   25 CONTINUE
      DSTA=0.D0
      DSTB=0.D0
      DSTAB=0.D0
      DO 50 I=1,3
      DSTA=PVA(I)*PVA(I) + DSTA
      DSTB=PVB(I)*PVB(I) + DSTB
      DSTAB=PVAB(I)*PVAB(I) + DSTAB
   50 CONTINUE
      DSTA=DSQRT(DSTA)
      DSTB=DSQRT(DSTB)
      DSTAB=DSQRT(DSTAB)
      CORR=K2MC3*DLOG((DSTA+DSTB+DSTAB)/(DSTA+DSTB-DSTAB))
 1000 FORMAT (1X,5(E12.5,1X)) 
      DTNEW=DSTAB/VLITE + CORR
      DT=ABS(DTNEW-DTOLD)
	IF (DT.LE.TOLERR) CONVRG=.TRUE.
C
C	   THE
	   END


	SUBROUTINE LITTIM(DIST12,DIST23,AUKM,VLIGHT,CORR12,CORR23,DTADT,
     $                  TTLTIM)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C:%S COMPUTE TWO WAY LIGHT TRAVEL TIME AND APPLY NECESSARY CORRECTIONS
C:COMPUTE ROUND TRIP RANGE DISTANCE BY ADDING THE OUT BOUNCE LEG /
C:DISTANCE TO THE BOUNCE RETURN LEG DISTANCE
C:CONVERT ROUND TRIP RANGE DISTANCE IN A.U. TO LIGHT TRAVEL TIME IN SECONDS
C:ADD THE OUT BOUNCE AND BOUNCE RETURN CORRECTIONS FOR/
C:GEODETIC CURVATURE AND CONVERT TO SECONDS
C:ADD THE SUMMED GEODESIC CURVATURE CORRECTIONS TO THE ROUND TRIP/
C:LIGHT TRAVEL TIME 
C:ADD THE APPROXIMATE E-M GEODESIC CURVATURE CORRECTION TO THE ROUND TRIP/
C:LIGHT TRAVEL TIME 
C:MULTIPLY THE CORRECTED LIGHT TRAVEL TIME BY THE RELATIVISTIC/
C:CLOCK CORRECTION TO CONVERT FROM COORDINATE TO PROPER TIME
C  REVISIONS
C     05/25/83 - REMOVE SUPERFLUOUS SCALE AND FORMAT STATEMENTS;
C              ADD E-M GEODESIC CURVATURE CORRECTION (CONSTANTS .27 NSEC)
C                 (THIS TERM VARIES BY +/- .04 NSEC)      RLR
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
 
      RANGE=(DIST12+DIST23)*AUKM
      TTLTIM=RANGE/VLIGHT + (CORR12+CORR23)*86400.D0 + 0.27D-9
C                                                 .27=APPROX E-M REL COR
      TTLTIM=TTLTIM*DTADT
C
C	   THE
	   END

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c	SUBROUTINE POINT(TLRFVEC,TELPOS,GEDLAT,DIST,VLITE,LHASPH,AZALSPH)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	SUBROUTINE POINT(TLRFVEC,TELPOS,GEDLAT,DIST,
     1		VLITE,LHASPH,AZALSPH)
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  Tue Oct 25, 1988 09:32:57
C     1) REPLACE "COMPILER DOUBLE PRECISION" WITH
C        "IMPLICIT DOUBLE PRECISION (A-H,O-Z)".
C     2) MAKE SURE STATEMENTS DON'T EXTEND BEYOND COLUMN 72.
C     3) CHANGE OPTIONAL COMPILE STATEMENTS TO COMMENTS.
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C:%S COMPUTE POINTING ANGLES
C:COMPUTE THE PART OF THE ABERRATION CORRECTION WHICH IS/
C:INDEPENDDENT OF THE PARTICULAR VELOCITY COMPONENT, THIS EQUALS TO/
C:THE NEGATIVE OF THE OUT BOUNCE LEG DISTANCE DIVIDED BY THE /
C:VELOCITY OF LIGHT IN A.U. PER DAY
C:DO FOR THE THREE COMPONENTS OF THE TRANSMITTER TO REFLECTOR/
C:POSITION VECTOR
C:MULTIPLY THE CORRESPONDING TRANSMITTER VELOCITY COMPONENT BY THE/
C:PREVIOUSLY COMPUTED ABERRATION FACTOR TO COMPUTE THE TOTAL /
C:ABERRATION CORRECTION FOR THE PARTICULAR POSITION VECTOR /
C:COMPONENT
C:ADD THE ABERRATION CORRECTION TO THE PARTICULAR POSITION VECTOR/
C:COMPONENT
C:ENDDO
C:MATRIX MULTIPLICATION (TRANSFORM THE TRANSMITTER TO REFLECTOR/
C:VECTOR FROM THE MEAN EQUATORIAL SYSTEM OF THE EPHEMERIS TO THE/
C:TRUE SYSTEM OF DATE BY PREMULTIPLYING THE ABERRATION /
C:CORRECTED VECTOR BY THE COMBINED NUTATION AND PRECESSION/
C:ROTATION MATRICES [N] AND [P])
C:MATRIX MULTIPLICATION (TRANSFORM THE TRANSMITTER TO REFLECTOR /
C:VECTOR FROM THE TRUE EQUATORIAL SYSTEM OF DATE TO THE BODY FIXED/
C:TERRESTRIAL SYSTEM OF DATE BY PREMULTIPLYING THE CURRENT VECTOR BY /
C:THE ROTATION MATRIX [S] THROUGH THE G.A.S.T.)
C:MATRIX MULTIPLICATION (TRANSFORM THE TRANSMITTER TO REFLECTOR /
C:VECTOR FROM THE BODY FIXED TERRESTRIAL SYSTEM OF DATE TO A LOCAL HOUR/
C:ANGLE - DECLINATION SYSTEM BY PREMULTIPLYING THE CURRENT VECTOR BY THE/
C:ROTATION MATRIX [L] THROUGH THE LONGITUDE OF THE TRANSMITTER)
C:COMPUTE SPHERICAL COORDINATES FROM RECTANGULAR COORDINATES/
C:(FOR THE HOUR ANGLE - DECLINATION SYSTEM)
C:MATRIX MULTIPLICATION (TRANSFORM THE TRANSMITTER TO REFLECTOR /
C:VECTOR FROM THE LOCAL HOUR ANGLE DECLINATION SYSTEM TO THE /
C:AZIMUTH - ALTITUDE SYSTEM BY PREMULTIPLYING THE CURRENT VECTOR BY THE/
C:ROTATION MATRIX [G] THROUGH THE GEODETIC COLATITUDE)
C:COMPUTE SPHERICAL COORDINATES FROM RECTANGULAR COORDINATES/
C:(FOR THE AZIMUTH - ALTITUDE SYSTEM)
C
C  REVISIONS:
C	11/17/83 -- CHANGED SIGN ON LHA.	RLR.
C	01/13/84 -- CHANGED SIGN ON FAC.	RLR.
C	01/24/84 -- CHANGED SIGN ON FAC BACK FOR NOW. RLR.
C       24 OCT 89 - CALCULATE LRA WHICH IS NOW IN /EPHREC/
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

	INCLUDE 'EPHREC.INC'

	INCLUDE 'BOUNCE.INC'

	INCLUDE 'DIRCTN.INC'

	INCLUDE 'PNT.INC'

      DOUBLE PRECISION TELPOS(6)
      DOUBLE PRECISION CELSPH(6)
      DOUBLE PRECISION TLRFVEC(6),CELTEL(6),BODTEL(6),LHATEL(6),
     $ LHASPH(6),AZALTEL(6),AZALSPH(6)
      DOUBLE PRECISION NUTPRM(6,3),GASTM(6,3),LONGM(6,3),LATM(6,3)
      COMMON/TWOPI/TWOPI,CDR,CASR,CTSR

      GO TO (200,300) LEGDIR
  200 DO 210 I=1,6
      DO 205 J=1,3
      NUTPRM(I,J)=TNUTPRM(I,J)
      GASTM(I,J)=TGASTM(I,J)
  205 CONTINUE
  210 CONTINUE
      GO TO 400
  300 DO 310 I=1,6
      DO 305 J=1,3
      NUTPRM(I,J)=RNUTPRM(I,J)
      GASTM(I,J)=RGASTM(I,J)
  305 CONTINUE
  310 CONTINUE
  400 CONTINUE
      FAC=-DIST/VLITE
      DO 100 I=1,3
	write(*,*) "Fac & changes",fac,
     1	fac*stvec(4), fac*stvec(5),fac*stvec(6)
  100 TLRFVEC(I)=TLRFVEC(I) + FAC*STVEC(I+3)
      CALL MATTRNS(NUTPRM,6,3)
      CALL MATMUL(NUTPRM,TLRFVEC,CELTEL,6,3,1)
      RECD(13+3*(NREFL+1))=CELTEL(1)
      RECD(14+3*(NREFL+1))=CELTEL(2)
      RECD(15+3*(NREFL+1))=CELTEL(3)
	CALL SPHERE(CELTEL, CELSPH)
	LRA = CELSPH(2)
      CALL MATTRNS(GASTM,6,3)
      CALL MATMUL(GASTM,CELTEL,BODTEL,6,3,1)
      CALL LATLONM(TELPOS,GEDLAT,LATM,LONGM)
      CALL MATTRNS(LONGM,6,3)
      CALL MATMUL(LONGM,BODTEL,LHATEL,6,3,1)
      CALL SPHERE(LHATEL,LHASPH)
      CALL MATTRNS(LATM,6,3)
      CALL MATMUL(LATM,LHATEL,AZALTEL,6,3,1)
      CALL SPHERE(AZALTEL,AZALSPH)

      AZALSPH(2) = 180.D0 - AZALSPH(2)/CDR
      IF (AZALSPH(2).LT.0.D0) AZALSPH(2) = AZALSPH(2) + 360.D0
      AZALSPH(3) = AZALSPH(3)/CDR
      LHASPH(2) = -LHASPH(2)/CDR/15.D0
      LHASPH(3) =  LHASPH(3)/CDR
C
C	   THE
	   END


	SUBROUTINE SPHERE(XYZ,SPHER)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C:%S COMPUTE SPHERICAL COORDINATES FROM RECTANGULAR COORDINATES
C:COMPUTE RHO*RHO = X*X + Y*Y 
C:COMPUTE RHO = SQRT(RHO*RHO) 
C:COMPUTE R = SQRT(RHO*RHO + Z*Z)
C:COMPUTE LONG = ATAN(Y/X)
C:COMPUTE LAT = ATAN(Z/RHO)
      DIMENSION XYZ(6),SPHER(6)
      RHOSQ=XYZ(1)*XYZ(1) + XYZ(2)*XYZ(2)
      RHO=DSQRT(RHOSQ)
      SPHER(1)=DSQRT(RHOSQ + XYZ(3)*XYZ(3))
      SPHER(2)=DATAN2(XYZ(2),XYZ(1))
      SPHER(3)=DATAN2(XYZ(3),RHO)
      DO 25 I=4,6
      SPHER(I)=0.D0
   25 CONTINUE
C
C	   THE
	   END


	SUBROUTINE LATLONM(TELPOS,GEDLAT,LATM,LONGM)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C:%S COMPUTE ROTATION MATRICES FOR GEODETIC COLATITUDE AND LONGITUDE
C:COMPUTE STATION GEODETIC COLATITUDE IN RADIANS /
C:FOR THE AUGMENTED ROTATION MATRIX, SET THE RATE OF THE COLATITUDE/
C:TO 0.0
C:CONSTRUCT AUGMENTED ROTATION MATRIX ( [G] FOR GEODETIC COLATITUDE,/ 
C:POSITIVE ROTATION THROUGH THE COLATITUDE ABOUT THE 2 AXIS, /
C:ROTATION FLAG TO +2)
C:FOR THE AUGMENTED ROTATION MATRIX, SET THE RATE OF THE LONGITUDE/
C:TO 0.0
C:CONSTRUCT AUGMENTED ROTATION MATRIX ( [L] FOR LONGITUDE, POSITIVE/
C:ROTATION THROUGH THE LONGITUDE ABOUT THE 3 AXIS, ROTATION FLAG /
C:TO +3)
      DOUBLE PRECISION TELPOS(6)
      DOUBLE PRECISION COLAT(2),LONG(2),LATM(6,3),LONGM(6,3)
      COMMON/TWOPI/TWOPI,CDR,CASR,CTSR
      COLAT(1)=TWOPI/4.D0 - GEDLAT*CDR
      COLAT(2)=0.D0
      CALL ROTMAT(+2,COLAT,LATM)
      LONG(1)=TELPOS(2)*CDR
      LONG(2)=0.D0
      CALL ROTMAT(+3,LONG,LONGM)
C
C	   THE
	   END


	SUBROUTINE CLKCOR(TJDUTC,TRANSM,EMUTC,DTADT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C:%S COMPUTE EPHEMERIS MINUS UTC AND RELATIVISTIC CLOCK CORRECTIONS
C:COMPUTE THE TIME DIFFERENCE, UTC JULIAN DATE MINUS  /
C:2415020.0 IN UNITS OF 10000 DAYS (THIS PROVIDES THE TIME/ 
C:ARGUMENT IN THE EXPANSIONS FOR THE MEAN ANOMALY AND ECCENTRICITY/
C:OF THE ORBIT OF THE SUN - SEE EXP. SUPP. OF EPH., P.98)
C:COMPUTE SQUARE AND CUBE OF THIS TIME DIFFERENCE 
C:COMPUTE MEAN ANOMALY OF THE SUN FROM ITS TIME EXPANSION/
C:CONVERT THE MEAN ANOMALY FROM DEGREES TO RADIANS
C:MODULAR FUNCTION (OBTAIN THE MEAN ANOMALY IN REVOLUTIONS) 
C:COMPUTE THE ECCENTRICITY OF THE ORBIT OF THE SUN FROM ITS TIME/
C:EXPANSION
C:COMPUTE SQUARE AND CUBE OF THE ECCENTRICITY
C:COMPUTE THE ECCENTRIC ANOMALY OF THE ORBIT OF THE SUN FROM ITS/
C:EXPANSION IN TERMS OF THE ECCENTRICITY AND MEAN ANOMALY (SEE
C:BROUWER AND CLEMENCE, P.76) 
C:MODULAR FUNCTION (FROM THE INPUT UTC JULIAN DATE + 0,5, OBTAIN UT / 
C:HOURS PAST MIDNIGHT)
C:CONVERT INPUT TELESCOPE LONGITUDE AND LATITUDE FROM DEGREES TO /
C:RADIANS 
C:OBTAIN THE DIFFERENCE ATOMIC TIME MINUS UTC (IN SECONDS)
C:COMPUTE THE TIME DIFFERENCE EPHEMERIS TIME MINUS UTC (EXPRESSED/
C:AS ATOMIC TIME - UTC + 32.15 SECONDS + RELATIVISTIC CLOCK /
C:CORRECTION TO CONVERT THE PROPER OR ATOMIC TIME TO COORDINATE TIME, SEE /
C:JPL TECHNICAL REPORT NO. 32 - 1306, P.16 - 17)
C:COMPUTE THE RELATIVISTIC DIFFERENTIAL RELATIONSHIP, IN SECONDS, TO /
C:CONVERT AN INTERVAL OF PROPER OR ATOMIC TIME TO AN INTERVAL OF /
C:COORDINATE TIME (SEE MULHOLLAND,
C:1972 PASP, 84, P.357, AND ALSO ABOVE JPL REFERENCE)
C  REVISIONS:
C     05/09/83 - REVISE ECC ANOM & EMUTC EQNS TO MATCH MIT.  RLR.

      DOUBLE PRECISION TRANSM(3)
      COMMON/TWOPI/TWOPI,CDR,CASR,CTSR

	INCLUDE 'DEFCMN.INC'

	INCLUDE 'DEVCOM.INC'

	INCLUDE 'FUNBLK.INC'

      DD=TJDUTC-2415020.D0
      BD=DD*1.0D-04
      BD2=BD*BD
      BD3=BD*BD2
      EMS=(358.475845D0 + 0.985600267D0*DD - 1.12D-05*BD2
     1		- 0.7D-07*BD3)*CDR
      EMS=DMOD(EMS,TWOPI)
      ECS = 0.01675104D0 - 1.1444D-05 * BD - 9.4D-09 * BD2
C.....OBTAIN ECCENTRIC ANOMALY USING THE ABOVE PARAMETERS (SEE BROUWER
C.....AND CLEMENCE, P. 76)
      U= EMS + ECS*DSIN(EMS)
      UT=DMOD(TJDUTC+0.5D0,1.0D0)
      UT=UT*TWOPI
      ELONG=TRANSM(2)*CDR
      PHI=TRANSM(3)*CDR
      CALL CUTABL(TJDUTC,AMUTC)
      EMUTC=AMUTC + 32.15D0 + 1.658D-03*DSIN(U) + 
     $ 1.67D-06*DCOS(PHI)*(DSIN(UT+ELONG)-DSIN(ELONG))
      COSU=DCOS(U)
      DTADT=1.0D0- 3.302D-10*COSU/(1.0D0 - ECS*COSU)-
     $  1.476D-10*DCOS(PHI)*DCOS(UT+ELONG)
      DTADTP= DTADT-1.D0
      IF (DEB(8)) WRITE(DUNIT,1000) AMUTC,EMUTC,DTADTP
 1000 FORMAT(1X,'CLKCOR: AMUTC=',E20.10,' EMUTC=',E20.10,
     1		' DTADT=1.0+',E20.10)
C
C	   THE
	   END


C      SUBROUTINE CUTABL(JDUTC,DATUT)
	SUBROUTINE CUTABL(JDUTC,DATUT)
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  THIS VERSION IS FROM "PREDICTION UPDATES" FOLDER
C  FOR NORMAL POINT PROGRAM.
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  Mon Aug 29, 1988 15:42:15
C     1) REPLACE "COMPILER DOUBLE PRECISION" WITH
C        "IMPLICIT DOUBLE PRECISION (A-H,O-Z)".
C     2) MAKE SURE STATEMENTS DON'T EXTEND BEYOND COLUMN 72.
C     3) CHANGE OPTIONAL COMPILE STATEMENTS TO COMMENTS. 
C     4) CHANGE IN-LINE COMMENTS TO COMMENT LINES. 
C     5) CHANGE HOLLERITH CONSTANTS (50H) TO STRING CONSTANTS. 
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  Wed Aug 31, 1988 10:25:06
C     REMOVE DATA STATEMENTS TO BLOCK DATA SUBPROGRAM
C  (Wed Nov 2, 1988 12:36:14,  ALSO MOVE "DATA LTIM")
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C 08 Mar 91, 1518: change "stop" to "call error"
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C   ---
C     GIVEN UTC, FIND THE REQUIRED PARAMETERS FOR COMPUTING THE
C     DIFFERENCE
C              AT - UTC = VALUE + RATE*JDUTC-EPOCH)
C     IN SECONDS, AND RETURN THE RESULT.  AT IS PRESUMED TO
C     BE IDENTIFIED WITH A.1(USNO)
C   ---
C     J D MULHOLLAND, JPL, 1971 JAN
C   ---
C     REFERENCES --
C              GUINOT ET AL, ANNUAL REPORTS, BUREAU INTERNATIONALE
C                   DE L'HEURE
C              P. MULLER, JPL TPOLY REPORTS
C   ---
C  Revisions:
C	05/28/85 - prepared for 7/1/85 leap second.
C	11/09/87 - PREPARED FOR 1/1/87 LEAP SECOND. V01. RLR.
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

	INCLUDE 'ATMAUX.INC'

	INCLUDE 'DEVCOM.INC'

	DOUBLE PRECISION JDUTC

C   ---
      DATUT = DZERO
      DO 10 K=1,LTIM,3
      EPOCH=TIME(K)
      DELTA = JDUTC - EPOCH
      IF (DELTA)    20,30,10
   10 CONTINUE
      WRITE (ierrout,1010) JDUTC
ccc      STOP
	errmsg=' CUTABLE: jd table exceeded.'
	call error(5,errmsg,0,0)
   20 IF (3.LT.K)   GO TO 40
      WRITE (ierrout,1000) JDUTC
      RETURN
   30 DATUT=TIME(K+1)
      RETURN
   40 K=K-3
      EPOCH=TIME(K)
      DTEMP=TIME(K+1)
      DATUT=TIME(K+2)*SECDAY
      DATUT = DTEMP + DATUT*(JDUTC-EPOCH)*DM10
      RETURN
C   ---
 1000 FORMAT (' JD EARLIER THAN AT-UTC TABLE, ZERO RETURNED,',
     1		' JD = ',6PD20.6)
 1010 FORMAT (' JD TABLE EXCEEDED IN SUBROUTINE CUTABL,',
     1		' EXECUTION TERMINATED, JD = ',6PD20.6)
C
C	   THE
	   END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c	SUBROUTINE UT1UTC(TJDUTC,EPOCH,EMUTC,UT1C)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	SUBROUTINE UT1UTC(TJDUTC,EMUTC,UT1C,EOSRC)
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  Tue Oct 25, 1988 13:13:14
C     1) REPLACE "COMPILER DOUBLE PRECISION" WITH
C        "IMPLICIT DOUBLE PRECISION (A-H,O-Z)".
C     2) CHANGE "REAL" TO "DOUBLE PRECISION".
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
c 02 May 90, 16:10:41-remove formal parameter epoch; was in /modinf/
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C:%S OBTAIN EARTH ROTATION PARAMETER UT1 MINUS UTC
C:(INPUT IS A JULIAN DATE, OUTPUT IS THE QUANTITY UT1 MINUS UTC)
C:IF THE JULIAN DATE IS WITHIN THE INTERPOLATION TIME SPAN
C:INTERPOLATE APPROPRIATE EARTH ROTATION PARAMETERS (FROM BIH VALUES,
C:UT1 MINUS UTC REQUIRED)
C:ELSE
C:EXTRAPOLATE APPROPRIATE EARTH ROTATION PARAMETERS (FROM USNO SERIES
C:7, UT1 MINUS UTC REQUIRED)
C:ENDIF
C:COMPUTE EMPIRICAL LINEAR + ANNUAL + LUNAL NODAL TERMS IN UT1, IN SECONDS
C:(INPUT TIME ARGUMENT IS THE TIME DIFFERENTIAL FROM A SPECIFIED EPOCH)
C:COMPUTE CORRECTION TO UT1 FOR PERIODIC TERMS DUE TO TIDAL BULGE
C:ADD THE EMPIRICAL AND TIDAL UT1 CORRECTIONS TO THE EARTH
C:ROTATION PARAMETER UT1 MINUS UTC
C
C  REVISIONS:
C	04/22/83 - REMOVE UTVAR FROM MIT PROCESSING. RLR
C	07/20/87 - ALLOW USER SELECTION OF UT1 TIDAL CALCS. V01. RLR.
C	09/02/87 - SUPPLY SOURCE OF UT1-UTC: ( ) NONE, (P)OLYNOMIAL 
C		   PREDICTION, (T)ABLULAR PREDICTIONS, RAPIS SERVICE OR
C		   CIRCULAR D.  IN THE FUTURE, PERHAPS WE CAN SAY 
C		   WHETHER IT WAS PREDICTION, RAPID SERVICE, OR CIRC D
C		   FOR TAB VALUES. THIS IS ALSO THE SOURCE FOR THE
C		   X & Y VALUES. V02. RLR.
C
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

	INCLUDE 'PDCMN.INC'

	INCLUDE 'DEFCMN.INC'

	INCLUDE 'DEVCOM.INC'

	INCLUDE 'U1UC.INC'

      CHARACTER*1 EOSRC

      T2=TJDUTC
      DUTV= 0.D0
      DUTT= 0.D0
      CALL USNOPL(TJDUTC,EMUTC,0,UT1C,DUMXP,DUMYP,EOSRC)
      IF (UTVARC) CALL UTVAR(T2,DUTV)
      IF (UTTIDE) CALL UT1TIDE(K2LOVE,DUTT)
      UT1C=UT1C + DUTV + DUTT
      IF (DEB(9)) WRITE(DUNIT,1000) UT1C
 1000 FORMAT(1X,'UT1UTC: UT1C ',E20.10)
C
C	   THE
	   END


	SUBROUTINE UTVAR(DIFJD,DUTV)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

	INCLUDE 'U1UC.INC'

	INCLUDE 'FUNBLK.INC'

	DUTV=UTDOT*DIFJD + UTSLP*DSIN(ELS) + UTCLP*DCOS(ELS)
     $ + UTSND*DSIN(EOM) + UTCND*DCOS(EOM)
C
C	   THE
	   END


	SUBROUTINE ELCORE(DEPS,DPSI)
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C:%S COMPUTE NUTATION CORRECTIONS FOR EARTH ELASTICITY AND FLUID CORE
C:(INPUT FROM THE COMMON OF THE FUNDAMENTAL ARGUMENTS: ANGLE OF /
C:ASCENDING NODE AND MEAN ANOMALY OF MOON, LUNAR ARGUMENT OF /
C:LATITUDE, MEAN ANOMALY OF SUN AND MEAN ELONGATION OF THE MOON FROM /
C:THE SUN ALL IN RADIANS; /
C:OUTPUT IS THE CORRECTIONS IN ? , THESE ARE CORRECTIONS TO /
C:WOOLARDS STANDARD NUTATION THEORY; SEE MELCHIOR, P., CEL. MECH. /
C:VOL. 4, P. 190, 1971)
C:COMPUTE ARGUMENT ANGLES FOR THE EXPANSIONS USED TO COMPUTE THE/
C:CORRECTIONS
C:COMPUTE THE CORRECTION TO THE OBLIQUITY FROM ITS EXPANSION
C:COMPUTE THE CORRECTION TO THE ? FROM ITS EXPANSION

	INCLUDE 'FUNBLK.INC'

	COMMON/TWOPI/TWOPI,CDR,CASR,CTSR

      A = 2.0D0*(F+EOM)
      B = A - 2.0D0*D
      C = B + EMS
      DD = A + EMM
      DEPS = 0.0022D0*DCOS(A) + 0.0202D0*DCOS(B) + 0.0056D0*DCOS(EMS)
     $ - 0.0086D0*DCOS(EOM) + 0.0008D0*DCOS(C) + 0.0004D0*DCOS(EMM)
     $ +0.0002D0*DCOS(DD)
      DPSI = -0.0043D0*DSIN(A) -0.0411D0*DSIN(B) + 0.0193D0*DSIN(EMS)
     $ +0.0441D0*DSIN(EOM) - 0.0017D0*DSIN(C) + 0.0036D0*DSIN(EMM)
     $ - 0.0003D0*DSIN(DD)
      DEPS=DEPS*CASR
      DPSI=DPSI*CASR
C
C	   THE
	   END


	SUBROUTINE DIPOLE(GSDTIME,DX,DY)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C:%S COMPUTE DIURNAL POLAR MOTION CORRECTIONS
C:(INPUT IS THE GREENWICH SIDEREAL TIME AND ALSO THROUGH THE COMMON / 
C:OF THE FUNDAMENTAL ARGUMENTS: ANGLE OF ASCENDING NODE AND /
C:MEAN ANOMALY OF MOON, LUNAR ARGUMENT OF LATITUDE, MEAN ANOMALY /
C:OF SUN AND THE MEAN ELONGATION OF THE MOON FROM THE SUN ALL IN/
C:RADIANS: OUTPUT IS THE CORRECTIONS IN THE X AND Y POSITIONS OF /
C:THE POLE IN RADIANS, SEE ?) 
C:COMPUTE ARGUMENT ANGLES FOR THE EXPANSIONS USED TO COMPUTE THE/
C:CORRECTIONS
C:COMPUTE THE DIURNAL CORRECTION TO THE POLAR MOTION IN X FROM ITS/
C:EXPANSION
C:COMPUTE THE DIURNAL CORRECTION TO THE POLAR MOTION IN Y FROM ITS/
C:EXPANSION
C:CONVERT THE X AND Y CORRECTIONS FROM ARC SECONDS TO RADIANS

	INCLUDE 'FUNBLK.INC'

      A = GSDTIME - 2.0D0*F
      B = A - 2.0D0*EOM
      C = B + 2.0D0 *D
      DD = B - EMM
      E = B + EOM
      DX = 0.0087D0*DSIN(GSDTIME) - 0.0065D0*DSIN(B) -
     1					0.0029D0*DSIN(C)
     $ - 0.0013D0*DSIN(DD) - 0.0012D0*DSIN(E) +
     3					0.0012D0*DSIN(GSDTIME-EOM)
     $ +0.0005D0*DSIN(GSDTIME-EMM) + 0.0005D0*DSIN(GSDTIME+EMM)
      DY = -0.0087D0*DCOS(GSDTIME) + 0.0065D0*DCOS(B) +
     1					0.0029D0*DCOS(C)
     $ + 0.0013D0*DCOS(DD) + 0.0012D0*DCOS(E) -
     3					0.0012D0*DCOS(GSDTIME-EOM)
     $ - 0.0005D0*DCOS(GSDTIME-EMM) - 0.0005D0*DCOS(GSDTIME+EMM)
      RETURN
C
C	   THE
	   END


	SUBROUTINE BSLYR(TJDEPH,BSSLYR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      BYR00=2415020.31352D0
      DAYS=365.24219879D0
      DDAYS=-8.56D-09
      D1900=1900.0D0
      D=TJDEPH - BYR00
      BSSLYR=D/DAYS 
      BSSLYR=D/(DAYS+DDAYS*BSSLYR) + D1900
C
C	   THE
	   END


	SUBROUTINE CNVCOOR(AUKM,SPHPOS,RECPOS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C:%S CONVERT COORDINATES FROM SPHERICAL TO RECTANGULAR, IN UNITS OF AU
C:(INPUT IS THE BODY CENTERED /
C:DISTANCE IN KM, EAST LONGITUDE AND /
C:LATITUDE BOTH IN DEGREES; OUTPUT IS RECTANGULAR BODY FIXED BODY/
C:CENTERED COORDINATES IN A.U.)
C:CONVERT STATION DISTANCE FROM KM TO A.U.
C:CONVERT STATION EAST LONGITUDE FROM DEGREES TO RADIANS
C:CONVERT STATION LATITUDE FROM DEGREES TO RADIANS
C:FOR THE RECTANGULAR COORDINATE CONVERSION, SET THE RATES OF THE/
C:STATION COORDINATES TO 0.0
C:COMPUTE RECTANGULAR COORDINATES FROM SPHERICAL COORDINATES
      DOUBLE PRECISION SPHPOS(3),TMPPOS(6),RECPOS(6)
      COMMON/TWOPI/TWOPI,CDR,CASR,CTSR
      TMPPOS(1)=SPHPOS(1)/AUKM
      TMPPOS(2)=SPHPOS(2)*CDR 
      TMPPOS(3)=SPHPOS(3)*CDR 
      DO 10 I=4,6
      TMPPOS(I)=0.D0
   10 CONTINUE
      CALL RECTNG(TMPPOS,RECPOS)
      RETURN
C
C	   THE
	   END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c	SUBROUTINE XYPOLE(TJDUTC,T1,EMUTC,XPOLE,YPOLE)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	SUBROUTINE XYPOLE(TJDUTC,T1,EMUTC,XPOLE,YPOLE)
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  Tue Oct 25, 1988 13:19:14
C     1) REPLACE "COMPILER DOUBLE PRECISION" WITH
C        "IMPLICIT DOUBLE PRECISION (A-H,O-Z)".
C     2) CHANGE "REAL" TO "DOUBLE PRECISION".
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C:%S OBTAIN POLAR MOTION PARAMETERS X AND Y OF THE POLE
C:IF THE JULIAN DATE IS WITHIN THE BIH DATA TIME SPAN
C:INTERPOLATE APPROPRIATE EARTH ROTATION PARAMETERS (FROM BIH VALUES,
C:POLAR MOTION COORDINATES X AND Y REQUIRED)
C:ELSE
C:EXTRAPOLATE APPROPRIATE EARTH ROTATION PARAMETERS (FROM USNO SERIES 7,
C:POLAR MOTION COORDINATES X AND Y REQUIRED)
C:ENDIF
C:COMPUTE THE RIGHT ASCENSION OF THE MEAN SUN AND ITS RATE
C:COMPUTE THE GREENWICH HOUR ANGLE OF THE SUN PLUS 12 HOURS (THIS IS
C:EQUAL TO THE FRACTIONAL PART OF THE JULIAN DATE IN RADIANS)
C:COMPUTE GREENWICH MEAN SIDEREAL TIME (THIS IS EQUAL TO THE R.A.
C:OF THE MEAN SUN + THE GREENWICH HOUR ANGLE OF THE MEAN SUN +
C:12 HOURS)
C:COMPUTE DIURNAL POLAR MOTION CORRECTIONS (INPUT TIME ARGUMENT IS
C:THE GREENWICH MEAN SIDEREAL TIME)
C:ADD DIURNAL POLAR MOTION CORRECTIONS TO THE EARTH ROTATION X AND
C:Y VALUES OF THE INSTANTANEOUS POLE WRT THE CONVENTIONAL
C:INTERNATIONAL ORIGIN
C  REVISIONS:
C	04/22/83 - ALLOW BYPASS OF DIPOLE CALL AS WAHR MODEL USED ON
C		   MIT PEPCONTAINS THIS EFFECT. RLR.
C	11/16/87 - ADD EOSRC TO USNOPL CALL.  NOT USED HERE. V01. RLR.
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

	INCLUDE 'PDCMN.INC'

      CHARACTER*1 EOSRC
      DOUBLE PRECISION RAMSN(2)
      COMMON/TWOPI/TWOPI,CDR,CASR,CTSR

      IWHICH=1
      CALL USNOPL(TJDUTC,EMUTC,IWHICH,UT1C,XPOLE,YPOLE,EOSRC)
      CALL RAMSUN(TJDUTC,RAMSN)
      GHAS=DMOD(TJDUTC,1.0D0)*TWOPI
      GMST=RAMSN(1) + GHAS
      IF (WAHR) GO TO 100
      CALL DIPOLE(GMST,DXPOLE,DYPOLE)
      XPOLE = XPOLE + DXPOLE
      YPOLE = YPOLE + DYPOLE
100	CONTINUE
C
C	   THE
	   END


	SUBROUTINE WOBBLE(TELPOS,XPOLE,YPOLE)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C:%S APPLY POLAR MOTION X,Y CORRECTIONS TO THE TELESCOPE
C:(INPUT IS THE TELESCOPE POSITION IN SPHERICAL COORDINATES WRT/
C:THE MEAN POLE AND ALSO THE POLAR MOTION X AND Y RECTANGULAR COORDINATES/
C:IN A W. LONG. SYSTEM OF THE INSTANTANEOUS POLE WRT THE MEAN POLE;/
C:OUTPUT IS THE TELESCOPE POSITION IN SPHERICAL COORDINATES WRT THE/
C:INSTANTANEOUS POLE)
C:COMPUTE RECTANGULAR TELESCOPE COORDINATES FROM THE INPUT SPHERICAL/ 
C:COORDINATES (X = R COS(LAT) COS(LONG), Y = R COS(LAT) SIN(LONG),/
C:Z = R SIN(LAT) )
C:CONVERT POLAR MOTION COORDINATES X AND Y FROM ARC SECONDS TO RADIANS
C:COMPUTE COS AND SIN OF POLAR MOTION COORDINATE X
C:COMPUTE COS AND SIN OF POLAR MOTION COORDINATE Y
C:ROTATE THE RECTANGULAR TELESCOPE COORDINATES ABOUT THE X AXIS/
C:THROUGH AN ANGLE MINUS POLAR MOTION COORDINATE Y (X = X, /
C:Y = Y COS(POLAR MOTION COORDINATE Y) - Z SIN(POLAR MOTION COORDINATE Y),/
C:Z = Y SIN(POLAR MOTION COORDINATE Y) + Z COS(POLAR MOTION COORDINATE Y) )
C:ROTATE THE NEW RECTANGULAR TELESCOPE COORDINATES ABOUT THE NEW /
C:Y AXIS THROUGH AN ANGLE POLAR MOTION COORDINATE X /
C:(X = X COS(POLAR MOTION COORDINATE X) - Z SIN(POLAR MOTION COORDINATE X)/
C:Y = Y, /
C:Z = X SIN(POLAR MOTION COORDINATE X) + Z COS(POLAR MOTION COORDINATE X) )
C:COMPUTE THE NEW TELESCOPE COORDINATES IN A SPHERICAL SYSTEM AND /
C:PUT THEM INTO THE INPUT TELESCOPE COORDINATE ARRAY (R = SQRT(X*X +/ 
C: Y*Y + Z*Z), LONG = ATAN(Y/X) IN DEGREES, LAT = ASIN(Z/R) IN /
C:DEGREES)
      DOUBLE PRECISION TELPOS(3)
      COMMON/TWOPI/TWOPI,CDR,CASR,CTSR

	INCLUDE 'DEFCMN.INC'

	INCLUDE 'DEVCOM.INC'
 
      Z = TELPOS(1)*DSIN(TELPOS(3)*CDR) 
      Y = TELPOS(1)*DCOS(TELPOS(3)*CDR) 
      X = Y*DCOS(TELPOS(2)*CDR)
      Y = Y*DSIN(TELPOS(2)*CDR)
      DELX =  XPOLE*CASR
      DELY = -YPOLE*CASR
      COSX = DCOS(DELX)
      SINX = DSIN(DELX)
      COSY = DCOS(DELY)
      SINY = DSIN(DELY)
      XP = X
      YP = Y*COSY - Z*SINY
      ZP = Y*SINY + Z*COSY
      X = XP*COSX - ZP*SINX
      Y = YP
      Z = XP*SINX + ZP*COSX
      TELPOS(1) = DSQRT(X*X + Y*Y + Z*Z)
      TELPOS(2) = DATAN2(Y,X)/CDR
      RHO=DSQRT(X*X + Y*Y)
      TELPOS(3) = DATAN2(Z,RHO)/CDR
      IF (DEB(12)) WRITE(DUNIT,1000) X,Y,Z,TELPOS 
 1000 FORMAT(' WOBBLE: X,Y,Z,TELPOS '/1X,6E20.10) 
C
C	   THE
	   END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c	SUBROUTINE USNOPL(TJDUTC,EMUTC,IWHICH,UT1C,XPOLE,YPOLE)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	SUBROUTINE USNOPL(TJDUTC,EMUTC,IWHICH,UT1C,XPOLE,YPOLE,EOSRC)
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  Tue Oct 25, 1988 13:31:21
C     1) REPLACE "COMPILER DOUBLE PRECISION" WITH
C        "IMPLICIT DOUBLE PRECISION (A-H,O-Z)".
C     2) MAKE SURE STATEMENTS DON'T EXTEND BEYOND COLUMN 72.
C     3) REMOVE IN-LINE COMMENTS.
C     4) CHANGE "REAL" TO "DOUBLE PRECISION".
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  Wed Mar 29, 1989 09:07:00
C     1) KLUDGE D.P. RELATIONAL EXPRESSIONS.
C  Wed May 31, 1989 14:05:32
C     1) REMOVE KLUDGE.
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C:%S EXTRAPOLATE APPROPRIATE EARTH ROTATION PARAMETERS
C:(FROM USNO SERIES 7 CIRCULAR)
C:COMPUTE A AND C ANGULAR ARGUMENTS
C:COMPUTE DYNAMICAL (OR EPHEMERIS) UTC
C:COMPUTE THE BESSELIAN YEAR EQUIVALENT OF THE DYNAMICAL UTC
C:MODULAR FUNCTION (THE BESSELIAN YEAR TO A FRACTION OF A BESSELIAN
C:YEAR)
C:IF UT1 MINUS UTC REQUIRED
C:COMPUTE THE VALUE OF UTC MINUS UT2 FROM ITS EXPANSION (THE EXPANSION
C:ARGUMENT IS THE FRACTIONAL BESSELIAN YEAR IN RADIANS)
C:COMPUTE EXTRAPOLATED UT1 MINUS UTC FROM ITS EXPANSION
C:ELSE
C:COMPUTE EXTRAPOLATED XPOLE AND YPOLE FROM THEIR EXPANSIONS
C:ENDIF
C  REVISIONS:
C	09/02/87 - SEND BACK SOURCE OF EARTH ORIENTATION INFO:
C		   ' '= NONE, 
C		   'T'= TABULAR (PREDICTIONS, RAPID SERVICE, OR
C			CIRCULAR D, OR
C		   'P'= USNO SERIES 7 POLYNOMIAL.  V01. RLR.
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

	INCLUDE 'USNOC.INC'

      DOUBLE PRECISION JDUTC
      CHARACTER*1 EOSRC
      COMMON/TWOPI/TWOPI,CDR,CASR,CTSR

	INCLUDE 'DEFCMN.INC'

	INCLUDE 'DEVCOM.INC'

      EOSRC= ' '
C				OR .0?
      JDUTC= TJDUTC - 2400000.5D0

      A=TWOPI*(JDUTC-ACJD)/365.25D0
      C=TWOPI*(JDUTC-ACJD)/435.0D0

C  SET UP CORRECTIONS FOR OLD BIH SYSTEM, IF NECESSARY
      DX=0.D0
      DT=0.D0
C				MAY 1, 1979
	IF (TJDUTC.LT.2443994.5D0) CALL BIH79(TJDUTC,DT,DX)
      IF (IWHICH.EQ.1) GO TO 25

C  UT1-UTC   (TRY TABULAR FORM, 1ST)
      CALL KUSTNER(TJDUTC,XDUM,YDUM,UT1C,IFLG)
      EOSRC= 'T'
      IF (IFLG.EQ.0) GO TO 20
      TJDEPH=TJDUTC + EMUTC/86400.0D0
      CALL BSLYR(TJDEPH,BSSLYR)
      BSSLYR=DMOD(BSSLYR,1.0D0)
      TWPIT=TWOPI*BSSLYR
      UT21=0.022D0*DSIN(      TWPIT) - 0.012D0*DCOS(      TWPIT) -
     1	   0.006D0*DSIN(2.0D0*TWPIT) + 0.007D0*DCOS(2.0D0*TWPIT)
      UT1C=C11 + C12*(JDUTC-UT1CJD) - UT21
      EOSRC= 'P'
   20 UT1C=UT1C + DT
      IF (DEB(10)) WRITE(DUNIT,1000) UT1C,EOSRC
 1000 FORMAT(1X,'USNOPL: UT1C=',E20.10,' EOSRC=',A1)
      GO TO 50

C  X & Y POLE  (TRY TABULAR FORM, 1ST)
   25 CALL KUSTNER(TJDUTC,XPOLE,YPOLE,UDUM,IFLG)
      EOSRC= 'T'
      IF (IFLG.EQ.0) GO TO 30
CCCCCCCCCCCCCCCCCCCC FUTURE CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C	COSA=COS(A)
C	SINA=SIN(A)
C	COSC=COS(C)
C	SINC=SIN(C)
C      XPOLE=C1 + C2*COSA + C3*SINA + C4*COSC + C5 *SINC
C      YPOLE=C6 + C7*COSA + C8*SINA + C9*COSC + C10*SINC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      XPOLE=C1 + C2*DCOS(A) + C3*DSIN(A) + C4*DCOS(C) + C5 *DSIN(C)
      YPOLE=C6 + C7*DCOS(A) + C8*DSIN(A) + C9*DCOS(C) + C10*DSIN(C)
      EOSRC= 'P'
   30 XPOLE=XPOLE + DX

      IF (DEB(10)) WRITE(DUNIT,1010) XPOLE,YPOLE,EOSRC
 1010 FORMAT(1X,'USNOPL: XPOLE,YPOLE=',2E20.10, ' EOSRC=',A1)

50	CONTINUE
C
C	   THE
	   END


	SUBROUTINE BIH79 (XJD,T,X)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C**  THIS PROGRAM VALID ON FTN4 AND FTN5 **
C   ***   CORRECTION FROM BIH1968 SYSTEM TO BIH1979
C     XJD IS INPUT JULIAN DATE.
C     T IS CORRECTION TO BE ADDED TO UT1
C     X IS CORRECTION TO BE ADDED TO X-COORDINATE 
C     THERE IS NO CORRECTION TO Y-COORDINATE
C     REFERENCE -- BIH CIRCULAR D150,  1979 MAY 3 
C     J. D. MULHOLLAND, UTEXAS 1980 MAY 
C   ***
      DATA ANN,SEMI/0.017203,0.034406/
      T = 0.0007D0*(DSIN(ANN*(XJD-2444048.5D0)) +
     1				DSIN(SEMI*(XJD-2444019.5D0)))
      X = 0.024D0*DSIN(ANN*(XJD-2443932.5D0))
     $  +0.007D0*DSIN(SEMI*(XJD-2443979.5D0))
C
C	   THE
	   END


	SUBROUTINE ENTSET(TIMARR,TIM,N,COEFS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION TIMARR(N),COEFS(N)
 
      DO 10 I=1,N
          COEFS(I)= 1.D0
          DO 5 J=1,N
           IF (I.EQ.J) GO TO 5
           COEFS(I)= (TIM-TIMARR(J))*COEFS(I)/(TIMARR(I)-TIMARR(J))
 5        CONTINUE
 10   CONTINUE
C
C	   THE
	   END


	DOUBLE PRECISION FUNCTION ENTRP(COEFS,DATARR,N)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION COEFS(N),DATARR(N)
      Y= 0.D0
      DO 10 I=1,N
 10   Y= Y+ COEFS(I)*DATARR(I)
      ENTRP= Y
C
C	   THE
	   END


	SUBROUTINE LRATE(NRECD,LREFL,LHA,DEC)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C  THIS ROUTINE DETERMINES THE ANGULAR RATE IN BOTH THE HA & DEC AXES 
C  AND PRINTS THEM WITH THE HA & DEC COORDINATES.  THESE VALUES CAN BE
C  USED FOR 107" LUNAR POINTING
C
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ RLR 6/83 $$$$$
      DOUBLE PRECISION LHA,DEC
 
	INCLUDE 'DEVCOM.INC'

	INCLUDE 'DEFCMN.INC'

	COMMON /LRTCMN/ OLHA(6),ODEC(6)
	SAVE /LRTCMN/
 
C  *15 TS/AS*3600 ASEC/DEG / 900 SEC -> ASEC/SEC
      DLHA= (LHA-OLHA(LREFL+2))*60.D0
C  *15.*3600. / 900. -> ASEC/SEC
      DDEC= (DEC-ODEC(LREFL+2))*4.D0
      OLHA(LREFL+2)= LHA
      ODEC(LREFL+2)= DEC
 
C  CONVERT HA & DEC TO UNITS, MIN, SEC & PRINT
      IF (NRECD.EQ.1) GO TO 100
      ID= DINT(LHA) 
      IMA= ABS(DINT((LHA-ID)*60.D0))
      SA= ABS(LHA-ID)*3600.D0-IMA*60.D0
      IH= DINT(DEC) 
      IMS= ABS(DINT((DEC-IH)*60.D0))
      ST= ABS(DEC-IH)*3600.D0-IMS*60.D0
      if (ioutdev .gt. 0) 
     x   WRITE(IOUTDEV,1000) ID,IMA,SA, IH,IMS,ST, DLHA, DDEC
 1000 FORMAT(5X,2(2X,I3,1X,I2,1X,F4.1),5X,2F7.2/) 
 
 100  RETURN
C
C	   THE
	   END


	SUBROUTINE RITIEPH(MODE, EPHFP, NREC)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C  RITIEPH CREATES, OPENS, WRITES, AND CLOSES AN ASCII LUNAR EPHEMERIS
C  FILE. THE FILE, SPECIFIED BY EPHFP, IS DIRECT ACCESS. THE
C  CALL TO CLOSE WRITES HEADER INFORMATION (E.G.,BEGINING AND ENDING
C  TIME OF THE EPHEMERIS) IN RECORDS 1-4.
C
C       INPUT:  MODE - 1=CREATE (IF NECESSARY) AND OPEN FILE
C                      2=WRITE ON FILE THE INFO IN ARRAY RECD
C                               IN COMMON EPHREC
C                      3=WRITE HEADER & CLOSE
C               RECD - THE RECORD TO BE OUTPUT (NOW IN COMMON)
C               NREC - IN MODE 1, NREC IS EPHEMERIS POINT SEPARATION,
C                      IN MODE 2, WRITE RECORD NUMBER NREC.
C
C       -- FROM /EPHREC/  --
C       FIRST AND LAST LUNAR RA AND DEC, SITE NUMBER, EPHEMERIS SOURCE
C
C
C       OUTPUT: FILE EPHFP WHOSE FORMAT IS AS FOLLOWS:
C          HEADER-
C              RECORD 1: START AND END TIME OF EPEMERIS FILE.
C                     2: STATION ID, NUMBER OF EPHEMERIS POINTS,
C                        EPEMERIS POINT SEPARATION, SITE NUMBER,
C                        AND EPHEMERIS SOURCE.
C                     3: BEGINNING LUNAR RA AND DEC.
C                     4: ENDING LUNAR RA AND DEC. 
C
C          FOR EPHEMERIS POINT NREC (FIRST RECORD IS 4+(NREC-1)*11+1)
C              RECORD     1: MJD, SECONDS, GAST, NREC
C                      2- 4: LIBRATION MATRIX (3(1x,f18.15)).
C                      5-10: VECTORS TO CENTER OF MOON AND
c			     EACH REFLECTOR (3p,3(1x,f18.15)).
C                        11: RANGES TO REFLECTORS IN SECONDS (5(1x,f14.12)).
C
C       COMMONS:
C         HEADER
C         EPHREC
C                                                               RLR
C
c  ascii version with lunar RA & DEC created in Oct 89.         TLR
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c 12 Jul 90, 1737 - write station id (obscode) to header through recd(3)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c 13 Jul 90, 1030 - Add gregorian dates to first record of header.  Dates
c	and times are passed in recd(4-9).
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c 01 Mar 91, 0953 - in format 5108, "F15.13" <- "F16.13" to fix overflow.
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c 08 Mar 91, 1423: add parameter to error for calling HP-UX exit; and
c	use "if(ios.NE.0)", not "if(ios.LT.0)" to test for calling error.
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
C
	INCLUDE 'DEVCOM.INC'
 
	INCLUDE 'EPHREC.INC'
 
	COMMON /HEADER/ HDR(34), IHDR(136)
	SAVE /HEADER/
 
        CHARACTER*16 EPHFP
        CHARACTER*80 MSG
        CHARACTER*80 ASCIIREC

C---------------------------------------------------------------------
        IF (MODE .NE. 1) GO TO 100

C**********************************************************************
C
C  FILE INITIALIZATION
C
C*********************************************************************

	lene=itrimlen(ephfp)
	MSG=' ERROR IN "RITIEPH": OPEN FILE "'//EPHFP(1:lene)//'"'
        OPEN(3,IOSTAT=IOS,ERR=10,
     1		FILE=patheph(1:leneph)//EPHFP(1:lene),FORM='FORMATTED',
     2		STATUS='UNKNOWN',ACCESS='DIRECT',RECL=80)
 10     IF (IOS.NE.0) CALL ERROR(ios,MSG,2130,IOS)

C  SAVE THE BEGINNING INT(JD) 
        HDR(1)= RECD(1)
C  EPHEMERIS POINT SEPARATION IN SEC
        IHDR(15)=NREC
        RETURN
C
C**********************************************************************
C
C  WRITE
C
C***********************************************************************
100     IF (MODE.NE.2) GO TO 200

5000	FORMAT(A80)
5108	FORMAT(1X,F9.0,1X,F9.2,1X,F16.13,
     2		'  --------- EPHEMERIS POINT #',I5)
5109	FORMAT(3(1X,F18.15))
5110	FORMAT(3p,3(1X,F18.15))
5112	FORMAT(5(1X,F14.12))
	MSG=' ERROR IN "RITIEPH": WRITE TO FILE "'//EPHFP//'"'

C 4 IS NUMBER OF RECORDS IN HEADER, (NREC-1)*11 IS TO SPACE PAST
C PREVIOUSLY WRITTEN SETS OF DATA RECORDS, AND THE EXTRA 1 IS
C TO GET PAST THE LAST RECORD OF THE PREVIOUS SET TO THE FIRST
C RECORD OF THE CURRENT SET.  IF THE LENGTH OF THE HEADER IS INCREASED,
C REPLACE THE 4 WITH THE NEW LENGTH.  SIMILARLY FOR THE LENGTH OF
C THE DATA RECORDS.
	KREC=4+(NREC-1)*11 + 1
 
C  GET BEGINNING TIME OR ENDING TIME
        IF (NREC.EQ.1) THEN
	  HDR(1) = RECD(1)
	  HDR(2) = RECD(2)
	ELSE
	  HDR(3) = RECD(1)
	  HDR(4) = RECD(2)
	ENDIF
 
C  ...AND WRITE THE RECORDS OUT

	WRITE(ASCIIREC,5108)(RECD(I),I=1,3),NREC
	ASCIIREC(80:80)=CHAR(10)
	WRITE(3,5000,IOSTAT=IOS,ERR=110,REC=KREC)ASCIIREC
	  KREC=KREC+1

	K1=4
	DO 801 I801=1,3
	K2=K1+2
	WRITE(ASCIIREC,5109)(RECD(I),I=K1,K2)
	ASCIIREC(80:80)=CHAR(10)
	WRITE(3,5000,IOSTAT=IOS,ERR=110,REC=KREC)ASCIIREC
	  KREC=KREC+1
	  K1=K1+3
801	CONTINUE

	K1=13
	DO 802 I802=1,6
	K2=K1+2
	WRITE(ASCIIREC,5110)(RECD(I),I=K1,K2)
	ASCIIREC(80:80)=CHAR(10)
	WRITE(3,5000,IOSTAT=IOS,ERR=110,REC=KREC)ASCIIREC
	  KREC=KREC+1
	  K1=K1+3
802	CONTINUE

	WRITE(ASCIIREC,5112)(RECD(I),I=31,35)
	ASCIIREC(80:80)=CHAR(10)
	WRITE(3,5000,IOSTAT=IOS,ERR=110,REC=KREC)ASCIIREC
	  KREC=KREC+1

	GOTO 111
 110    IF (IOS.NE.0) CALL ERROR(ios,MSG,2132,IOS )
111	CONTINUE
        RETURN
C************************************************************************
C
C  CLOSE
C
C************************************************************************
 
C  ...BUT FIRST WRITE HEADER RECORD
200	CONTINUE

C     INCLUDE DUMMY ID #, AND REAL SITE NUMBER AND EPHEMERIS SOURCE.
	IHDR(13) = recd(3)
c get gregorian dates and times: add 0.1 to prevent 14.99999 -> 14
	do 201 i201=1,12
	j201=i201+3
201	ihdr(i201)=recd(j201)+0.1d0
 
C...AND THE NUMBER OF RECORDS ON THIS FILE.
        IHDR(14) = NREC
 
	MSG=' ERROR IN "RITIEPH": WRITE HEADER TO FILE "'//EPHFP//'"'
5008	FORMAT(2(1X,F9.0,1X,F9.2),2x,
     1		2(i2.2,'/'),i2.2,',',2(i2.2,':'),i2.2,' - ',
     2		2(i2.2,'/'),i2.2,',',2(i2.2,':'),i2.2)
5009	FORMAT(5(1X,I8))
5010	FORMAT(2(1X,D22.15))

	WRITE(ASCIIREC,5008)(HDR(I),I=1,4),(ihdr(I),I=1,12)
	ASCIIREC(80:80)=CHAR(10)
	WRITE(3,5000,IOSTAT=IOS,ERR=210,REC=1)ASCIIREC

	WRITE(ASCIIREC,5009)(IHDR(I),I=13,15),SITENO,EPHSRC
	ASCIIREC(80:80)=CHAR(10)
	WRITE(3,5000,IOSTAT=IOS,ERR=210,REC=2)ASCIIREC

	WRITE(ASCIIREC,5010)(LRADEC(I),I=1,2)
	ASCIIREC(80:80)=CHAR(10)
	WRITE(3,5000,IOSTAT=IOS,ERR=210,REC=3)ASCIIREC

	WRITE(ASCIIREC,5010)(LRADEC(I),I=3,4)
	ASCIIREC(80:80)=CHAR(10)
	WRITE(3,5000,IOSTAT=IOS,ERR=210,REC=4)ASCIIREC

	GOTO 211
 210    IF (IOS.NE.0) CALL ERROR(ios,MSG,2133, IOS)
 
211	CONTINUE
        CLOSE(3)  
C
C	   THE
	   END


	SUBROUTINE UT1TIDE(K2LOVE,DUT1)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C:%S COMPUTE CORRECTION TO UT1 FOR PERIODIC TERMS DUE TO TIDAL BULGE
C:(INPUT IS THE K2 LOVE NUMBER AND ALSO THROUGH THE COMMON OF THE/
C:FUNDAMENTAL ARGUMENTS: ANGLE OF ASCENDING NODE AND MEAN ANOMALY OF/ 
C:MOON, LUNAR ARGUMENT OF LATITUDE, MEAN ANOMALY OF SUN AND THE MEAN/ 
C:ELONGATION OF THE MOON FROM THE SUN ALL IN DEGREES! OUTPUT IS THE/
C:CORRECTION TO UT1 IN SECONDS)
C:COMPUTE THE TIDAL BULGE CORRECTION TO UT1 FROM ITS EXPANSION
C  REF: YODER, ET AL., J. GEOPHYS. ES. 86, 881-891, 1981.

        DOUBLE PRECISION K2LOVE
 
	INCLUDE 'DEFCMN.INC'

	INCLUDE 'DEVCOM.INC'

	INCLUDE 'FUNBLK.INC'
 
C  QUASI-MONTHLY TERMS: 27.9->34.9 DAYS 
      QMTIDE=(.0437D0*DSIN( ( EMM + 2.D0*F +      EOM))
     X       +.1056D0*DSIN( ( EMM + 2.D0*F + 2.D0*EOM))
     X       +.0210D0*DSIN( (-EMM + 2.D0*F + 2.D0*EOM + 2.D0*D)) 
     X       +.0318D0*DSIN( (       2.D0*F           ))
     X       +.3413D0*DSIN( (       2.D0*F +      EOM))
     X       +.8252D0*DSIN( (       2.D0*F + 2.D0*EOM))
     X       +.0781D0*DSIN( (2.D0*D))
     X       +.0106D0*DSIN( (EOM)) * DCOS( (2.D0*D))
     X       +.0360D0*(1.D0 - .12D0*DCOS( (EOM))) * DSIN( (2.D0*EMM)))
     X          *1.D-3
 
C  QUASI-WEEKLY TERMS: 5.6->15.4 DAYS
      QWTIDE=   (-.0188D0*DSIN( (-EMM + 2.D0*F +      EOM))
     X           -.0463D0*DSIN( (-EMM + 2.D0*F + 2.D0*EOM))
     X           +.8788D0*(1. - .131D0*DCOS( (EOM))) * DSIN( ( EMM))
     X           +.1940D0*(1. - .137D0*DCOS( (EOM))) *
     4					DSIN( (-EMM + 2.D0*D)))
     X           *1.D-3
 
C  3.2...=MOMENTUM->LOVE CONVERSION RATIO
      DUT1 = -K2LOVE * 3.24138D0 * (QMTIDE + QWTIDE)
        IF (DEB(11)) WRITE(DUNIT,1000) DUT1
 1000   FORMAT(' UT1TIDE: DUT1 ',E20.10)
        RETURN
C
C	   THE
	   END


C	SUBROUTINE DATEQRY(MODE,JD)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
	SUBROUTINE DATEQRY(MODE,JDINT,JDF)
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C  READ INITIAL OR FINAL JULIAN DATES FROM KEYBOARD
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  Wed Mar 8, 1989 16:12:36
C     1) ADD "IMPLICIT DOUBLE PRECISION (A-H,O-Z)".
C     2) CONVERT TO INTEGER AND FRACTION PARTS OF J.D.
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C.....
      DOUBLE PRECISION JDINT, JDF
      CHARACTER*7 PRLIT(2)
	character*80 linein
      INTEGER Y,M,D,H,MM,S

	INCLUDE 'DEFCMN.INC'

	INCLUDE 'DEVCOM.INC'

      DATA PRLIT /'INITIAL', 'FINAL  '/

	m=100
	d=100
	y=100
	h=100
	mm=100
	s=100
	if(mode .NE. 3 .and. ioutdev .gt. 0) 
     x     WRITE(IOUTDEV,1001) PRLIT(MODE)
1001  FORMAT(/' ENTER ',A7,' JULIAN DATE (MM DD YY HH MM SS): ')
5	read(indev,'(a80)') linein
	if(linein(1:10) .EQ. '          ') goto 10000
	READ(linein,*,end=10,ERR=10) M,D,Y,H,MM,S
      IF (Y.LT.0 .OR. Y.GT.99) GO TO 10
      IF (M.LT.1 .OR. M.GT.12) GO TO 10
      IF (D.LT.1 .OR. D.GT.31) GO TO 10
      IF (H.LT.0 .OR. H.GT.23) GO TO 10
      IF (MM.LT.0.OR.MM.GT.59) GO TO 10
      IF (S.LT.0 .OR. S.GT.59) GO TO 10
      CALL GRTJD(Y,M,D,H,MM,S,JDINT,JDF)
	goto 10000
 
10    WRITE(ierrout,1010)m,d,y,h,mm,s
1010  FORMAT(1X,'You entered ',6i8,'; ---- TRY AGAIN!') 
      GO TO 5
10000	continue
C
C	   THE
	   END


	SUBROUTINE POLIN(PMTITLE,CS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C  READ POLAR MOTION & UT1-UTC POLYNOMIAL COEFFICIENTS FROM 
C  FILE 'UTPOLE'.
C                                                           RLR 2/84
cc  Fri Dec 15 15:10:38 CST 1989, use pathname in open.   tlr
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c 08 Mar 91, 1423: add parameter to error for calling HP-UX exit.
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

	include 'DEVCOM.INC'

      DOUBLE PRECISION CS(14) 
	CHARACTER*30 PMTITLE
	CHARACTER*80 MSG
C
	MSG=' ERROR IN "POLIN": OPEN "UTPOLE".'
      OPEN(1,IOSTAT=IOS,ERR=11,
     1		FILE=pathfil(1:lenfil)//'UTPOLE',STATUS='OLD')
C
	MSG=' ERROR IN "POLIN": READ TITLE.'
      READ(1,1000,ERR=11) PMTITLE
 1000 FORMAT(A30)
	MSG=' ERROR IN "POLIN": READ CS VALUES.'
      READ(1,*,ERR=11) (CS(I),I=1,5)
      READ(1,*,ERR=11) (CS(I),I=6,10)
      READ(1,*,ERR=11) (CS(I),I=11,12)
      READ(1,*,ERR=11) (CS(I),I=13,14)
 
      CLOSE(1)
      RETURN
 
11    CALL ERROR(ios,MSG,9010,IOS)
C
C	   THE
	   END

